# IO.Swagger - the C# library for the Cerebral API

The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data

This C# SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- SDK version: 1.0.0
- Build date: 2022-11-23T18:10:29.615Z
- Build package: class io.swagger.codegen.languages.CSharpClientCodegen
    For more information, please visit [https://www.workiva.com](https://www.workiva.com)

## Frameworks supported
- .NET 4.0 or later
- Windows Phone 7.1 (Mango)

## Dependencies
- [RestSharp](https://www.nuget.org/packages/RestSharp) - 105.1.0 or later
- [Json.NET](https://www.nuget.org/packages/Newtonsoft.Json/) - 7.0.0 or later

The DLLs included in the package may not be the latest version. We recommned using [NuGet] (https://docs.nuget.org/consume/installing-nuget) to obtain the latest version of the packages:
```
Install-Package RestSharp
Install-Package Newtonsoft.Json
```

NOTE: RestSharp versions greater than 105.1.0 have a bug which causes file uploads to fail. See [RestSharp#742](https://github.com/restsharp/RestSharp/issues/742)

## Installation
Run the following command to generate the DLL
- [Mac/Linux] `/bin/sh build.sh`
- [Windows] `build.bat`

Then include the DLL (under the `bin` folder) in the C# project, and use the namespaces:
```csharp
using IO.Swagger.Api;
using IO.Swagger.Client;
using Model;
```

## Getting Started

```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using Model;

namespace Example
{
    public class Example
    {
        public void main()
        {
            
            var apiInstance = new APIHealthApi();

            try
            {
                // Health check
                BaseResponseOfMapOfstringAndstring result = apiInstance.HealthCheckUsingGET();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling APIHealthApi.HealthCheckUsingGET: " + e.Message );
            }
        }
    }
}
```

<a name="documentation-for-api-endpoints"></a>
## Documentation for API Endpoints

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIHealthApi* | [**HealthCheckUsingGET**](docs/APIHealthApi.md#healthcheckusingget) | **GET** /health | Health check
*AdministrativeTasksApi* | [**DeleteWorkspaceUsingDELETE**](docs/AdministrativeTasksApi.md#deleteworkspaceusingdelete) | **DELETE** /api/v1/admin/account | Delete a single workspace
*AdministrativeTasksApi* | [**ExportWorkspaceUsingGET**](docs/AdministrativeTasksApi.md#exportworkspaceusingget) | **GET** /api/v1/admin/export | Export a single workspace
*AdministrativeTasksApi* | [**FindWorkspaceFilesBySizeUsingGET**](docs/AdministrativeTasksApi.md#findworkspacefilesbysizeusingget) | **GET** /api/v1/admin/usage/filesBySize | Retrieve workspace files by size
*AdministrativeTasksApi* | [**GetWorkspaceQueryUsageUsingGET**](docs/AdministrativeTasksApi.md#getworkspacequeryusageusingget) | **GET** /api/v1/admin/usage/query | Retrieve workspace query usage
*AdministrativeTasksApi* | [**GetWorkspaceUploadUsageUsingGET**](docs/AdministrativeTasksApi.md#getworkspaceuploadusageusingget) | **GET** /api/v1/admin/usage/upload | Retrieve workspace upload usage
*AdministrativeTasksApi* | [**ImportDataUsingPOST**](docs/AdministrativeTasksApi.md#importdatausingpost) | **POST** /api/v1/admin/import | Import data
*AdministrativeTasksApi* | [**ValidateFilesUsingPOST**](docs/AdministrativeTasksApi.md#validatefilesusingpost) | **POST** /api/v1/admin/validation/files | Validate files
*AdministrativeTasksApi* | [**ValidateTablesUsingPOST**](docs/AdministrativeTasksApi.md#validatetablesusingpost) | **POST** /api/v1/admin/validation/tables | Validate tables
*ConnectionManagementApi* | [**GetConnectionUsingGET**](docs/ConnectionManagementApi.md#getconnectionusingget) | **GET** /api/v1/connections/{connectionId} | Get connection details
*ConnectionManagementApi* | [**GetRefreshBatchStatusUsingGET**](docs/ConnectionManagementApi.md#getrefreshbatchstatususingget) | **GET** /api/v1/connections/batch/refresh/{batchId} | Gets the status of a batch refresh
*ConnectionManagementApi* | [**GetRefreshStatusUsingGET**](docs/ConnectionManagementApi.md#getrefreshstatususingget) | **GET** /api/v1/connections/{connectionId}/status | Get connection refresh status
*ConnectionManagementApi* | [**ListConnectionsUsingGET**](docs/ConnectionManagementApi.md#listconnectionsusingget) | **GET** /api/v1/connections | List connections
*ConnectionManagementApi* | [**RefreshBatchUsingPOST**](docs/ConnectionManagementApi.md#refreshbatchusingpost) | **POST** /api/v1/connections/batch/refresh | Refresh batch of connections
*ConnectionManagementApi* | [**RefreshConnectionUsingPOST**](docs/ConnectionManagementApi.md#refreshconnectionusingpost) | **POST** /api/v1/connections/{connectionId}/refresh | Refresh connection
*FileManagementApi* | [**DeleteFileUsingDELETE**](docs/FileManagementApi.md#deletefileusingdelete) | **DELETE** /api/v1/file/{fileId} | Delete a single file
*FileManagementApi* | [**DownloadFileUsingGET**](docs/FileManagementApi.md#downloadfileusingget) | **GET** /api/v1/file/{fileId}/download | Download a single file
*FileManagementApi* | [**ExportFileToSpreadsheetsUsingPOST**](docs/FileManagementApi.md#exportfiletospreadsheetsusingpost) | **POST** /api/v1/file/{fileId}/export | Export a file to spreadsheets
*FileManagementApi* | [**GetErrorsUsingGET**](docs/FileManagementApi.md#geterrorsusingget) | **GET** /api/v1/file/{fileId}/error | Retrieve errors
*FileManagementApi* | [**GetFileUsingGET**](docs/FileManagementApi.md#getfileusingget) | **GET** /api/v1/file/{fileId} | Retrieve a single file
*FileManagementApi* | [**GetFilesUsingGET**](docs/FileManagementApi.md#getfilesusingget) | **GET** /api/v1/file | Retrieve a list of files
*FileManagementApi* | [**UploadFileUsingPOST**](docs/FileManagementApi.md#uploadfileusingpost) | **POST** /api/v1/file | Upload a single file
*FileManagementApi* | [**ValidateFilenameUsingGET**](docs/FileManagementApi.md#validatefilenameusingget) | **GET** /api/v1/file/validateName | Validate whether a file with the filename can be uploaded to the table
*FolderManagementApi* | [**CreateFolderUsingPOST**](docs/FolderManagementApi.md#createfolderusingpost) | **POST** /api/v1/folder | Create a new folder
*FolderManagementApi* | [**DeleteFolderUsingDELETE**](docs/FolderManagementApi.md#deletefolderusingdelete) | **DELETE** /api/v1/folder/{folderId} | Delete a single folder
*FolderManagementApi* | [**GetFolderUsingGET**](docs/FolderManagementApi.md#getfolderusingget) | **GET** /api/v1/folder/{folderId} | Retrieve a single folder
*FolderManagementApi* | [**ListChildrenUsingGET**](docs/FolderManagementApi.md#listchildrenusingget) | **GET** /api/v1/folder/{folderId}/children | Retrieve list of folder contents
*FolderManagementApi* | [**ListFoldersUsingGET**](docs/FolderManagementApi.md#listfoldersusingget) | **GET** /api/v1/folder | Retrieve a list of folders
*FolderManagementApi* | [**SearchUsingGET**](docs/FolderManagementApi.md#searchusingget) | **GET** /api/v1/entity | Search
*FolderManagementApi* | [**SetChildrenUsingPOST**](docs/FolderManagementApi.md#setchildrenusingpost) | **POST** /api/v1/folder/{folderId}/children | Move content into a folder
*FolderManagementApi* | [**UpdateFolderUsingPUT**](docs/FolderManagementApi.md#updatefolderusingput) | **PUT** /api/v1/folder/{folderId} | Update a single folder
*ParameterManagementApi* | [**CreateParameterUsingPOST**](docs/ParameterManagementApi.md#createparameterusingpost) | **POST** /api/v1/parameter | Create parameter
*ParameterManagementApi* | [**DeleteParameterUsingDELETE**](docs/ParameterManagementApi.md#deleteparameterusingdelete) | **DELETE** /api/v1/parameter/{parameterId} | Delete Parameter
*ParameterManagementApi* | [**GetParameterUsingGET**](docs/ParameterManagementApi.md#getparameterusingget) | **GET** /api/v1/parameter/{parameterId} | Get Parameter
*ParameterManagementApi* | [**ListParametersUsingGET**](docs/ParameterManagementApi.md#listparametersusingget) | **GET** /api/v1/parameter | Get Parameters
*ParameterManagementApi* | [**UpdateParameterUsingPUT**](docs/ParameterManagementApi.md#updateparameterusingput) | **PUT** /api/v1/parameter/{parameterId} | Update Parameter
*PivotViewManagementApi* | [**CreatePivotViewUsingPOST**](docs/PivotViewManagementApi.md#createpivotviewusingpost) | **POST** /api/v1/pivotview | Create a new pivot view
*PivotViewManagementApi* | [**DeletePivotViewUsingDELETE**](docs/PivotViewManagementApi.md#deletepivotviewusingdelete) | **DELETE** /api/v1/pivotview/{pivotViewId} | Delete a single pivot view
*PivotViewManagementApi* | [**DownloadPivotViewTokenUsingGET**](docs/PivotViewManagementApi.md#downloadpivotviewtokenusingget) | **GET** /api/v1/pivotview/{pivotViewId}/token | This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
*PivotViewManagementApi* | [**DownloadPivotViewUsingGET**](docs/PivotViewManagementApi.md#downloadpivotviewusingget) | **GET** /api/v1/pivotview/{pivotViewId}/download | This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
*PivotViewManagementApi* | [**GetPivotViewUsingGET**](docs/PivotViewManagementApi.md#getpivotviewusingget) | **GET** /api/v1/pivotview/{pivotViewId} | Retrieve a single pivot view
*PivotViewManagementApi* | [**ListPivotViewsUsingGET**](docs/PivotViewManagementApi.md#listpivotviewsusingget) | **GET** /api/v1/pivotview | Retrieve a list of pivot views
*PivotViewManagementApi* | [**UpdatePivotViewUsingPUT**](docs/PivotViewManagementApi.md#updatepivotviewusingput) | **PUT** /api/v1/pivotview/{pivotViewId} | Update a single pivot view
*QueryManagementApi* | [**CancelQueryUsingDELETE**](docs/QueryManagementApi.md#cancelqueryusingdelete) | **DELETE** /api/v1/queryresult/{queryResultId} | Cancel a running query
*QueryManagementApi* | [**CreateQueryUsingPOST**](docs/QueryManagementApi.md#createqueryusingpost) | **POST** /api/v1/query | Create a new query
*QueryManagementApi* | [**DeleteQueryUsingDELETE**](docs/QueryManagementApi.md#deletequeryusingdelete) | **DELETE** /api/v1/query/{queryId} | Delete a single query
*QueryManagementApi* | [**DownloadQueryResultUsingGET**](docs/QueryManagementApi.md#downloadqueryresultusingget) | **GET** /api/v1/queryresult/{queryResultId}/download | Download a query result
*QueryManagementApi* | [**ExportQueryResultToSpreadsheetsUsingPOST**](docs/QueryManagementApi.md#exportqueryresulttospreadsheetsusingpost) | **POST** /api/v1/queryresult/{queryResultId}/export | Export query result to spreadsheets
*QueryManagementApi* | [**GetDependenciesUsingGET**](docs/QueryManagementApi.md#getdependenciesusingget) | **GET** /api/v1/query/{queryId}/dependencies | Retrieve dependencies
*QueryManagementApi* | [**GetQueryColumnDataUsingPOST**](docs/QueryManagementApi.md#getquerycolumndatausingpost) | **POST** /api/v1/query/data | Retrieve query column data
*QueryManagementApi* | [**GetQueryResultUsingGET**](docs/QueryManagementApi.md#getqueryresultusingget) | **GET** /api/v1/queryresult/{queryResultId} | Retrieve a single query result
*QueryManagementApi* | [**GetQueryUsingGET**](docs/QueryManagementApi.md#getqueryusingget) | **GET** /api/v1/query/{queryId} | Retrieve a single query
*QueryManagementApi* | [**GetTablesDependentOnQueryUsingGET**](docs/QueryManagementApi.md#gettablesdependentonqueryusingget) | **GET** /api/v1/query/{queryId}/dependents | Retrieve a list of dependents
*QueryManagementApi* | [**IsQueryValidUsingPOST**](docs/QueryManagementApi.md#isqueryvalidusingpost) | **POST** /api/v1/query/validation | Parses the query to determine if it is valid
*QueryManagementApi* | [**ListQueriesUsingGET**](docs/QueryManagementApi.md#listqueriesusingget) | **GET** /api/v1/query | Retrieve list of queries
*QueryManagementApi* | [**ListQueryResultsUsingGET**](docs/QueryManagementApi.md#listqueryresultsusingget) | **GET** /api/v1/queryresult | Retrieve a list of query results
*QueryManagementApi* | [**PreviewQueryUsingPOST**](docs/QueryManagementApi.md#previewqueryusingpost) | **POST** /api/v1/query/preview/{tableId} | Preview a query
*QueryManagementApi* | [**RunQueryUsingPOST**](docs/QueryManagementApi.md#runqueryusingpost) | **POST** /api/v1/queryresult | Execute a query
*QueryManagementApi* | [**UpdateQueryUsingPUT**](docs/QueryManagementApi.md#updatequeryusingput) | **PUT** /api/v1/query/{queryId} | Update a single query
*SelectListManagementApi* | [**CreateSelectListUsingPOST**](docs/SelectListManagementApi.md#createselectlistusingpost) | **POST** /api/v1/selectlist | Create a new select list
*SelectListManagementApi* | [**DeleteUsingDELETE**](docs/SelectListManagementApi.md#deleteusingdelete) | **DELETE** /api/v1/selectlist/{selectListId} | Delete a single select list
*SelectListManagementApi* | [**GetSelectListUsingGET**](docs/SelectListManagementApi.md#getselectlistusingget) | **GET** /api/v1/selectlist/{selectListId} | Retrieve a single select list
*SelectListManagementApi* | [**ListSelectListsUsingGET**](docs/SelectListManagementApi.md#listselectlistsusingget) | **GET** /api/v1/selectlist | Retrieve a list of select lists
*SelectListManagementApi* | [**UpdateSelectListUsingPUT**](docs/SelectListManagementApi.md#updateselectlistusingput) | **PUT** /api/v1/selectlist/{selectListId} | Update a single select list
*SharedTableManagementApi* | [**CreateSharedTableUsingPOST**](docs/SharedTableManagementApi.md#createsharedtableusingpost) | **POST** /api/v1/sharedtable | Create a new shared table
*SharedTableManagementApi* | [**DeleteSharedTableUsingDELETE**](docs/SharedTableManagementApi.md#deletesharedtableusingdelete) | **DELETE** /api/v1/sharedtable/{sharedTableId} | Delete a single shared table
*SharedTableManagementApi* | [**GetSharedTableUsingGET**](docs/SharedTableManagementApi.md#getsharedtableusingget) | **GET** /api/v1/sharedtable/{sharedTableId} | Retrieve a single shared table
*SharedTableManagementApi* | [**ListSharedTablesUsingGET**](docs/SharedTableManagementApi.md#listsharedtablesusingget) | **GET** /api/v1/sharedtable | Retrieve a list of shared tables
*TableManagementApi* | [**CreateTableUsingPOST**](docs/TableManagementApi.md#createtableusingpost) | **POST** /api/v1/table | Create a new table
*TableManagementApi* | [**DeleteTableUsingDELETE**](docs/TableManagementApi.md#deletetableusingdelete) | **DELETE** /api/v1/table/{tableId} | Delete a single table
*TableManagementApi* | [**GetDependentsUsingGET**](docs/TableManagementApi.md#getdependentsusingget) | **GET** /api/v1/table/{tableId}/dependents | Retrieve a list of dependents
*TableManagementApi* | [**GetImportInfoUsingGET**](docs/TableManagementApi.md#getimportinfousingget) | **GET** /api/v1/table/{tableId}/importInfo | Retrieve import information
*TableManagementApi* | [**GetTableUsingGET**](docs/TableManagementApi.md#gettableusingget) | **GET** /api/v1/table/{tableId} | Retrieve a single table
*TableManagementApi* | [**GetTablesUsingGET**](docs/TableManagementApi.md#gettablesusingget) | **GET** /api/v1/table | Retrieve a list of tables
*TableManagementApi* | [**ImportFileUsingPOST**](docs/TableManagementApi.md#importfileusingpost) | **POST** /api/v1/table/{tableId}/import | Import a single file
*TableManagementApi* | [**ImportFromSpreadsheetsUsingPOST**](docs/TableManagementApi.md#importfromspreadsheetsusingpost) | **POST** /api/v1/table/{tableId}/spreadsheet/import | Import from spreadsheets
*TableManagementApi* | [**UnimportFileUsingDELETE**](docs/TableManagementApi.md#unimportfileusingdelete) | **DELETE** /api/v1/table/{tableId}/import/{fileId} | Unimport a single file
*TableManagementApi* | [**UpdateTableUsingPUT**](docs/TableManagementApi.md#updatetableusingput) | **PUT** /api/v1/table/{tableId} | Update a single table
*TagManagementApi* | [**CreateTagUsingPOST**](docs/TagManagementApi.md#createtagusingpost) | **POST** /api/v1/tag | Create a new tag
*TagManagementApi* | [**DeleteTagUsingDELETE**](docs/TagManagementApi.md#deletetagusingdelete) | **DELETE** /api/v1/tag/{tagId} | Delete a single tag
*TagManagementApi* | [**ListTagsUsingGET**](docs/TagManagementApi.md#listtagsusingget) | **GET** /api/v1/tag | Retrieve a list of tags
*TagManagementApi* | [**UpdateTagUsingPUT**](docs/TagManagementApi.md#updatetagusingput) | **PUT** /api/v1/tag/{tagId} | Update a single tag
*TokenManagementApi* | [**CreateTokenUsingPOST**](docs/TokenManagementApi.md#createtokenusingpost) | **POST** /api/v1/token | Create a new token
*TokenManagementApi* | [**DownloadFileUsingGET1**](docs/TokenManagementApi.md#downloadfileusingget1) | **GET** /api/v1/token/{tokenId} | Download a single file
*UtilitiesApi* | [**ParseDateUsingPOST**](docs/UtilitiesApi.md#parsedateusingpost) | **POST** /api/v1/util/datetime | Parse a date


<a name="documentation-for-models"></a>
## Documentation for Models

 - [Model.BaseResponseOfCollectionOfFolderableDto](docs/BaseResponseOfCollectionOfFolderableDto.md)
 - [Model.BaseResponseOfConnectionDto](docs/BaseResponseOfConnectionDto.md)
 - [Model.BaseResponseOfConnectionRunDto](docs/BaseResponseOfConnectionRunDto.md)
 - [Model.BaseResponseOfFileMetaDto](docs/BaseResponseOfFileMetaDto.md)
 - [Model.BaseResponseOfFolderDto](docs/BaseResponseOfFolderDto.md)
 - [Model.BaseResponseOfGlobalParameterDto](docs/BaseResponseOfGlobalParameterDto.md)
 - [Model.BaseResponseOfImportInfoDto](docs/BaseResponseOfImportInfoDto.md)
 - [Model.BaseResponseOfMapOfstringAndstring](docs/BaseResponseOfMapOfstringAndstring.md)
 - [Model.BaseResponseOfPivotViewDto](docs/BaseResponseOfPivotViewDto.md)
 - [Model.BaseResponseOfQueryColumnDataDto](docs/BaseResponseOfQueryColumnDataDto.md)
 - [Model.BaseResponseOfQueryDto](docs/BaseResponseOfQueryDto.md)
 - [Model.BaseResponseOfQueryResultDto](docs/BaseResponseOfQueryResultDto.md)
 - [Model.BaseResponseOfRefreshBatchDto](docs/BaseResponseOfRefreshBatchDto.md)
 - [Model.BaseResponseOfSelectListDto](docs/BaseResponseOfSelectListDto.md)
 - [Model.BaseResponseOfSharedTableDto](docs/BaseResponseOfSharedTableDto.md)
 - [Model.BaseResponseOfSpreadsheetInfoDto](docs/BaseResponseOfSpreadsheetInfoDto.md)
 - [Model.BaseResponseOfTableDto](docs/BaseResponseOfTableDto.md)
 - [Model.BaseResponseOfTagDto](docs/BaseResponseOfTagDto.md)
 - [Model.BaseResponseOfTokenDto](docs/BaseResponseOfTokenDto.md)
 - [Model.BaseResponseOfValidateFilesDto](docs/BaseResponseOfValidateFilesDto.md)
 - [Model.BaseResponseOfValidateTablesDto](docs/BaseResponseOfValidateTablesDto.md)
 - [Model.BaseResponseOflong](docs/BaseResponseOflong.md)
 - [Model.BaseResponseOfstring](docs/BaseResponseOfstring.md)
 - [Model.Column](docs/Column.md)
 - [Model.ColumnDto](docs/ColumnDto.md)
 - [Model.ColumnInfoDto](docs/ColumnInfoDto.md)
 - [Model.ConnectionDto](docs/ConnectionDto.md)
 - [Model.ConnectionRunDto](docs/ConnectionRunDto.md)
 - [Model.DatetimeDto](docs/DatetimeDto.md)
 - [Model.ExportFileDto](docs/ExportFileDto.md)
 - [Model.ExportQueryResultDto](docs/ExportQueryResultDto.md)
 - [Model.FileMetaDto](docs/FileMetaDto.md)
 - [Model.FolderDto](docs/FolderDto.md)
 - [Model.FolderableDto](docs/FolderableDto.md)
 - [Model.GlobalParameterDto](docs/GlobalParameterDto.md)
 - [Model.ImportDto](docs/ImportDto.md)
 - [Model.ImportErrorDto](docs/ImportErrorDto.md)
 - [Model.ImportFromSpreadsheetDto](docs/ImportFromSpreadsheetDto.md)
 - [Model.ImportInfoDto](docs/ImportInfoDto.md)
 - [Model.MapOfstringAndobject](docs/MapOfstringAndobject.md)
 - [Model.MapOfstringAndstring](docs/MapOfstringAndstring.md)
 - [Model.MultiError](docs/MultiError.md)
 - [Model.PagedResponseOfConnectionDto](docs/PagedResponseOfConnectionDto.md)
 - [Model.PagedResponseOfFileMetaDto](docs/PagedResponseOfFileMetaDto.md)
 - [Model.PagedResponseOfFolderDto](docs/PagedResponseOfFolderDto.md)
 - [Model.PagedResponseOfFolderableDto](docs/PagedResponseOfFolderableDto.md)
 - [Model.PagedResponseOfGlobalParameterDto](docs/PagedResponseOfGlobalParameterDto.md)
 - [Model.PagedResponseOfImportErrorDto](docs/PagedResponseOfImportErrorDto.md)
 - [Model.PagedResponseOfPivotViewDto](docs/PagedResponseOfPivotViewDto.md)
 - [Model.PagedResponseOfQueryDto](docs/PagedResponseOfQueryDto.md)
 - [Model.PagedResponseOfQueryResultDto](docs/PagedResponseOfQueryResultDto.md)
 - [Model.PagedResponseOfSelectListDto](docs/PagedResponseOfSelectListDto.md)
 - [Model.PagedResponseOfSharedTableDto](docs/PagedResponseOfSharedTableDto.md)
 - [Model.PagedResponseOfTableDto](docs/PagedResponseOfTableDto.md)
 - [Model.PagedResponseOfTagDto](docs/PagedResponseOfTagDto.md)
 - [Model.PivotDefinitionDto](docs/PivotDefinitionDto.md)
 - [Model.PivotViewDefinitionColumnDto](docs/PivotViewDefinitionColumnDto.md)
 - [Model.PivotViewDefinitionFilterDto](docs/PivotViewDefinitionFilterDto.md)
 - [Model.PivotViewDefinitionRowDto](docs/PivotViewDefinitionRowDto.md)
 - [Model.PivotViewDefinitionValueDto](docs/PivotViewDefinitionValueDto.md)
 - [Model.PivotViewDto](docs/PivotViewDto.md)
 - [Model.QueryColumnDataDto](docs/QueryColumnDataDto.md)
 - [Model.QueryDependencyDto](docs/QueryDependencyDto.md)
 - [Model.QueryDto](docs/QueryDto.md)
 - [Model.QueryParameterDto](docs/QueryParameterDto.md)
 - [Model.QueryResultDto](docs/QueryResultDto.md)
 - [Model.QueryTextDto](docs/QueryTextDto.md)
 - [Model.RefreshBatchDto](docs/RefreshBatchDto.md)
 - [Model.RefreshConnectionDto](docs/RefreshConnectionDto.md)
 - [Model.SelectListDto](docs/SelectListDto.md)
 - [Model.SharedTableDto](docs/SharedTableDto.md)
 - [Model.SingleError](docs/SingleError.md)
 - [Model.SpreadsheetInfoDto](docs/SpreadsheetInfoDto.md)
 - [Model.StartValidateFilesDto](docs/StartValidateFilesDto.md)
 - [Model.TableDto](docs/TableDto.md)
 - [Model.TableSchema](docs/TableSchema.md)
 - [Model.TagDto](docs/TagDto.md)
 - [Model.TokenDto](docs/TokenDto.md)
 - [Model.UniqueConstraintDto](docs/UniqueConstraintDto.md)
 - [Model.ValidateFilesDto](docs/ValidateFilesDto.md)
 - [Model.ValidateTablesDto](docs/ValidateTablesDto.md)


## Documentation for Authorization

### oauth

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: N/A

