# IO.Swagger.Api.AdministrativeTasksApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DeleteWorkspaceUsingDELETE**](AdministrativeTasksApi.md#deleteworkspaceusingdelete) | **DELETE** /api/v1/admin/account | Delete a single workspace
[**ExportWorkspaceUsingGET**](AdministrativeTasksApi.md#exportworkspaceusingget) | **GET** /api/v1/admin/export | Export a single workspace
[**FindWorkspaceFilesBySizeUsingGET**](AdministrativeTasksApi.md#findworkspacefilesbysizeusingget) | **GET** /api/v1/admin/usage/filesBySize | Retrieve workspace files by size
[**GetWorkspaceQueryUsageUsingGET**](AdministrativeTasksApi.md#getworkspacequeryusageusingget) | **GET** /api/v1/admin/usage/query | Retrieve workspace query usage
[**GetWorkspaceUploadUsageUsingGET**](AdministrativeTasksApi.md#getworkspaceuploadusageusingget) | **GET** /api/v1/admin/usage/upload | Retrieve workspace upload usage
[**ImportDataUsingPOST**](AdministrativeTasksApi.md#importdatausingpost) | **POST** /api/v1/admin/import | Import data
[**ValidateFilesUsingPOST**](AdministrativeTasksApi.md#validatefilesusingpost) | **POST** /api/v1/admin/validation/files | Validate files
[**ValidateTablesUsingPOST**](AdministrativeTasksApi.md#validatetablesusingpost) | **POST** /api/v1/admin/validation/tables | Validate tables


<a name="deleteworkspaceusingdelete"></a>
# **DeleteWorkspaceUsingDELETE**
> BaseResponseOfstring DeleteWorkspaceUsingDELETE ()

Delete a single workspace

Deletes all information in the workspace of the request. <b>This is a final operation and can't be undone</b>. Any state left in the workspace due to an error is in an indeterminate state and shouldn't be trusted. Some non-private information may be kept for auditing and metric purposes.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteWorkspaceUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();

            try
            {
                // Delete a single workspace
                BaseResponseOfstring result = apiInstance.DeleteWorkspaceUsingDELETE();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.DeleteWorkspaceUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="exportworkspaceusingget"></a>
# **ExportWorkspaceUsingGET**
> BaseResponseOfTokenDto ExportWorkspaceUsingGET ()

Export a single workspace

Creates a file representing the entirety of the requested workspace and returns a token. Use the [`Download a single file endpoint`](ref:wdata-downloadfileusingget) to exchange the token for the file.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ExportWorkspaceUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();

            try
            {
                // Export a single workspace
                BaseResponseOfTokenDto result = apiInstance.ExportWorkspaceUsingGET();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.ExportWorkspaceUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**BaseResponseOfTokenDto**](BaseResponseOfTokenDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="findworkspacefilesbysizeusingget"></a>
# **FindWorkspaceFilesBySizeUsingGET**
> PagedResponseOfFileMetaDto FindWorkspaceFilesBySizeUsingGET (int? limit = null, string cursor = null, long? offset = null)

Retrieve workspace files by size

Returns a paged collection of the file meta associated with the workspace of the request, ordered by size.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class FindWorkspaceFilesBySizeUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();
            var limit = 56;  // int? | The number of file meta objects to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve workspace files by size
                PagedResponseOfFileMetaDto result = apiInstance.FindWorkspaceFilesBySizeUsingGET(limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.FindWorkspaceFilesBySizeUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **int?**| The number of file meta objects to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfFileMetaDto**](PagedResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getworkspacequeryusageusingget"></a>
# **GetWorkspaceQueryUsageUsingGET**
> BaseResponseOflong GetWorkspaceQueryUsageUsingGET (string startDate = null, string stopDate = null)

Retrieve workspace query usage

Returns a Long that represents the number of bytes queried by the workspace of the request since the start time provided.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetWorkspaceQueryUsageUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();
            var startDate = startDate_example;  // string | The earliest date of usage to consider (optional)  (default to 1970-01-01)
            var stopDate = stopDate_example;  // string | The end date of usage to consider (optional)  (default to 9999-01-01)

            try
            {
                // Retrieve workspace query usage
                BaseResponseOflong result = apiInstance.GetWorkspaceQueryUsageUsingGET(startDate, stopDate);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.GetWorkspaceQueryUsageUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **string**| The earliest date of usage to consider | [optional] [default to 1970-01-01]
 **stopDate** | **string**| The end date of usage to consider | [optional] [default to 9999-01-01]

### Return type

[**BaseResponseOflong**](BaseResponseOflong.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getworkspaceuploadusageusingget"></a>
# **GetWorkspaceUploadUsageUsingGET**
> BaseResponseOflong GetWorkspaceUploadUsageUsingGET (string startDate = null, string stopDate = null)

Retrieve workspace upload usage

Returns a Long that represents the number of bytes uploaded by the workspace associated with this request from the start time provided to now.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetWorkspaceUploadUsageUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();
            var startDate = startDate_example;  // string | The starting point to begin considering usage (optional)  (default to 1970-01-01)
            var stopDate = stopDate_example;  // string | The ending point when considering usage (optional)  (default to 9999-01-01)

            try
            {
                // Retrieve workspace upload usage
                BaseResponseOflong result = apiInstance.GetWorkspaceUploadUsageUsingGET(startDate, stopDate);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.GetWorkspaceUploadUsageUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **string**| The starting point to begin considering usage | [optional] [default to 1970-01-01]
 **stopDate** | **string**| The ending point when considering usage | [optional] [default to 9999-01-01]

### Return type

[**BaseResponseOflong**](BaseResponseOflong.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="importdatausingpost"></a>
# **ImportDataUsingPOST**
> BaseResponseOfstring ImportDataUsingPOST (System.IO.Stream file = null, bool? wipe = null)

Import data

By default, deletes all information in the workspace of the request. <b>This is a final operation and can't be undone.</b>  Any state left in the workspace due to an error is in an indeterminate state and shouldn't be trusted. Some non-private information may be kept for auditing and metric purposes. After the delete, it then imports the tables, tags, and queries in the provided cb file into the workspace. <br><br>This is an asynchronous operation. Returns a 201 when the file is correctly decoded and its tables, queries, and tags are saved. Files continue to import after this call completes.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ImportDataUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();
            var file = new System.IO.Stream(); // System.IO.Stream | The file containing workspace information to import (optional) 
            var wipe = true;  // bool? | wipe (optional)  (default to true)

            try
            {
                // Import data
                BaseResponseOfstring result = apiInstance.ImportDataUsingPOST(file, wipe);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.ImportDataUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **file** | **System.IO.Stream**| The file containing workspace information to import | [optional] 
 **wipe** | **bool?**| wipe | [optional] [default to true]

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="validatefilesusingpost"></a>
# **ValidateFilesUsingPOST**
> BaseResponseOfValidateFilesDto ValidateFilesUsingPOST (StartValidateFilesDto validateFilesDto)

Validate files

Validates files associated with the provided table ID. Validation repairs any files in an inconsistent state, and deletes those without enough state to recover. All files deleted or repaired are returned.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ValidateFilesUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();
            var validateFilesDto = new StartValidateFilesDto(); // StartValidateFilesDto | The representation of the file to validate

            try
            {
                // Validate files
                BaseResponseOfValidateFilesDto result = apiInstance.ValidateFilesUsingPOST(validateFilesDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.ValidateFilesUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **validateFilesDto** | [**StartValidateFilesDto**](StartValidateFilesDto.md)| The representation of the file to validate | 

### Return type

[**BaseResponseOfValidateFilesDto**](BaseResponseOfValidateFilesDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="validatetablesusingpost"></a>
# **ValidateTablesUsingPOST**
> BaseResponseOfValidateTablesDto ValidateTablesUsingPOST ()

Validate tables

Validates the tables in the workspace associated with the request. Validation returns an entity that indicates the tables deleted due to bad state, and those with enough state and repaired.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ValidateTablesUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new AdministrativeTasksApi();

            try
            {
                // Validate tables
                BaseResponseOfValidateTablesDto result = apiInstance.ValidateTablesUsingPOST();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AdministrativeTasksApi.ValidateTablesUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**BaseResponseOfValidateTablesDto**](BaseResponseOfValidateTablesDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

