# IO.Swagger.Api.ConnectionManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetConnectionUsingGET**](ConnectionManagementApi.md#getconnectionusingget) | **GET** /api/v1/connections/{connectionId} | Get connection details
[**GetRefreshBatchStatusUsingGET**](ConnectionManagementApi.md#getrefreshbatchstatususingget) | **GET** /api/v1/connections/batch/refresh/{batchId} | Gets the status of a batch refresh
[**GetRefreshStatusUsingGET**](ConnectionManagementApi.md#getrefreshstatususingget) | **GET** /api/v1/connections/{connectionId}/status | Get connection refresh status
[**ListConnectionsUsingGET**](ConnectionManagementApi.md#listconnectionsusingget) | **GET** /api/v1/connections | List connections
[**RefreshBatchUsingPOST**](ConnectionManagementApi.md#refreshbatchusingpost) | **POST** /api/v1/connections/batch/refresh | Refresh batch of connections
[**RefreshConnectionUsingPOST**](ConnectionManagementApi.md#refreshconnectionusingpost) | **POST** /api/v1/connections/{connectionId}/refresh | Refresh connection


<a name="getconnectionusingget"></a>
# **GetConnectionUsingGET**
> BaseResponseOfConnectionDto GetConnectionUsingGET (string connectionId, string workspaceId = null)

Get connection details

Returns details about a specific connection, based on its ID

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetConnectionUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ConnectionManagementApi();
            var connectionId = connectionId_example;  // string | The ID of the connection to return details about
            var workspaceId = workspaceId_example;  // string | workspaceId (optional) 

            try
            {
                // Get connection details
                BaseResponseOfConnectionDto result = apiInstance.GetConnectionUsingGET(connectionId, workspaceId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ConnectionManagementApi.GetConnectionUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **connectionId** | **string**| The ID of the connection to return details about | 
 **workspaceId** | **string**| workspaceId | [optional] 

### Return type

[**BaseResponseOfConnectionDto**](BaseResponseOfConnectionDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getrefreshbatchstatususingget"></a>
# **GetRefreshBatchStatusUsingGET**
> BaseResponseOfRefreshBatchDto GetRefreshBatchStatusUsingGET (string batchId, string workspaceId = null)

Gets the status of a batch refresh

Returns details about a specific batch refresh, based on its ID.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetRefreshBatchStatusUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ConnectionManagementApi();
            var batchId = batchId_example;  // string | The ID of the batch to return details about
            var workspaceId = workspaceId_example;  // string | workspaceId (optional) 

            try
            {
                // Gets the status of a batch refresh
                BaseResponseOfRefreshBatchDto result = apiInstance.GetRefreshBatchStatusUsingGET(batchId, workspaceId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ConnectionManagementApi.GetRefreshBatchStatusUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **batchId** | **string**| The ID of the batch to return details about | 
 **workspaceId** | **string**| workspaceId | [optional] 

### Return type

[**BaseResponseOfRefreshBatchDto**](BaseResponseOfRefreshBatchDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getrefreshstatususingget"></a>
# **GetRefreshStatusUsingGET**
> BaseResponseOfConnectionRunDto GetRefreshStatusUsingGET (string connectionId, string workspaceId = null, string jobId = null)

Get connection refresh status

Returns details about a specific connection refresh status, based on its ID. To retrieve details about a specific refresh, provide its 'jobId'.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetRefreshStatusUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ConnectionManagementApi();
            var connectionId = connectionId_example;  // string | The ID of the connection to return details about
            var workspaceId = workspaceId_example;  // string | workspaceId (optional) 
            var jobId = jobId_example;  // string | The ID of the job running for a connection (optional) 

            try
            {
                // Get connection refresh status
                BaseResponseOfConnectionRunDto result = apiInstance.GetRefreshStatusUsingGET(connectionId, workspaceId, jobId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ConnectionManagementApi.GetRefreshStatusUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **connectionId** | **string**| The ID of the connection to return details about | 
 **workspaceId** | **string**| workspaceId | [optional] 
 **jobId** | **string**| The ID of the job running for a connection | [optional] 

### Return type

[**BaseResponseOfConnectionRunDto**](BaseResponseOfConnectionRunDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listconnectionsusingget"></a>
# **ListConnectionsUsingGET**
> PagedResponseOfConnectionDto ListConnectionsUsingGET (string sourceType = null, string destinationType = null, string sourceId = null, string destinationId = null, int? limit = null, string cursor = null, long? offset = null)

List connections

A pageable endpoint to list data connections between features of the Workiva platform

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListConnectionsUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ConnectionManagementApi();
            var sourceType = sourceType_example;  // string | The type of file or item the connection pulls data from (optional) 
            var destinationType = destinationType_example;  // string | The type of file or item the connection sends data to (optional) 
            var sourceId = sourceId_example;  // string | The ID of the file or item the connection pulls data from (optional) 
            var destinationId = destinationId_example;  // string | The ID of the file or item the connection sends data to (optional) 
            var limit = 56;  // int? | The number of connections to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // List connections
                PagedResponseOfConnectionDto result = apiInstance.ListConnectionsUsingGET(sourceType, destinationType, sourceId, destinationId, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ConnectionManagementApi.ListConnectionsUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sourceType** | **string**| The type of file or item the connection pulls data from | [optional] 
 **destinationType** | **string**| The type of file or item the connection sends data to | [optional] 
 **sourceId** | **string**| The ID of the file or item the connection pulls data from | [optional] 
 **destinationId** | **string**| The ID of the file or item the connection sends data to | [optional] 
 **limit** | **int?**| The number of connections to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfConnectionDto**](PagedResponseOfConnectionDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="refreshbatchusingpost"></a>
# **RefreshBatchUsingPOST**
> BaseResponseOfRefreshBatchDto RefreshBatchUsingPOST (List<RefreshConnectionDto> refreshConnectionDtos)

Refresh batch of connections

Refreshes multiple connections within the same spreadsheet, based on ID.When connecting to multiple spreadsheets, tables or other destinations, use the [`singular refresh connection`](ref:wdata-refreshconnectionusingpost) instead. `usePreviousDestinationParameters` and  `usePreviousSourceParameters` will use the exact parameters of your previous run; any new parameters you’ve provided will be ignored.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class RefreshBatchUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ConnectionManagementApi();
            var refreshConnectionDtos = new List<RefreshConnectionDto>(); // List<RefreshConnectionDto> | refreshConnectionDtos

            try
            {
                // Refresh batch of connections
                BaseResponseOfRefreshBatchDto result = apiInstance.RefreshBatchUsingPOST(refreshConnectionDtos);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ConnectionManagementApi.RefreshBatchUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **refreshConnectionDtos** | [**List<RefreshConnectionDto>**](RefreshConnectionDto.md)| refreshConnectionDtos | 

### Return type

[**BaseResponseOfRefreshBatchDto**](BaseResponseOfRefreshBatchDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="refreshconnectionusingpost"></a>
# **RefreshConnectionUsingPOST**
> BaseResponseOfConnectionRunDto RefreshConnectionUsingPOST (string connectionId, RefreshConnectionDto refreshConnectionDto)

Refresh connection

Refreshes a specific connection, based on its ID

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class RefreshConnectionUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ConnectionManagementApi();
            var connectionId = connectionId_example;  // string | The ID of the connection to refresh
            var refreshConnectionDto = new RefreshConnectionDto(); // RefreshConnectionDto | refreshConnectionDto

            try
            {
                // Refresh connection
                BaseResponseOfConnectionRunDto result = apiInstance.RefreshConnectionUsingPOST(connectionId, refreshConnectionDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ConnectionManagementApi.RefreshConnectionUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **connectionId** | **string**| The ID of the connection to refresh | 
 **refreshConnectionDto** | [**RefreshConnectionDto**](RefreshConnectionDto.md)| refreshConnectionDto | 

### Return type

[**BaseResponseOfConnectionRunDto**](BaseResponseOfConnectionRunDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

