# IO.Swagger.Api.FileManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DeleteFileUsingDELETE**](FileManagementApi.md#deletefileusingdelete) | **DELETE** /api/v1/file/{fileId} | Delete a single file
[**DownloadFileUsingGET**](FileManagementApi.md#downloadfileusingget) | **GET** /api/v1/file/{fileId}/download | Download a single file
[**ExportFileToSpreadsheetsUsingPOST**](FileManagementApi.md#exportfiletospreadsheetsusingpost) | **POST** /api/v1/file/{fileId}/export | Export a file to spreadsheets
[**GetErrorsUsingGET**](FileManagementApi.md#geterrorsusingget) | **GET** /api/v1/file/{fileId}/error | Retrieve errors
[**GetFileUsingGET**](FileManagementApi.md#getfileusingget) | **GET** /api/v1/file/{fileId} | Retrieve a single file
[**GetFilesUsingGET**](FileManagementApi.md#getfilesusingget) | **GET** /api/v1/file | Retrieve a list of files
[**UploadFileUsingPOST**](FileManagementApi.md#uploadfileusingpost) | **POST** /api/v1/file | Upload a single file
[**ValidateFilenameUsingGET**](FileManagementApi.md#validatefilenameusingget) | **GET** /api/v1/file/validateName | Validate whether a file with the filename can be uploaded to the table


<a name="deletefileusingdelete"></a>
# **DeleteFileUsingDELETE**
> BaseResponseOfstring DeleteFileUsingDELETE (string fileId)

Delete a single file

Unstages the file with the provided ID. The file must have a STAGED status; if the file isn't STAGED, returns a 409 status. If the file isn't found, this is a no-op.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteFileUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var fileId = fileId_example;  // string | The unique identifier of the file

            try
            {
                // Delete a single file
                BaseResponseOfstring result = apiInstance.DeleteFileUsingDELETE(fileId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.DeleteFileUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **string**| The unique identifier of the file | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="downloadfileusingget"></a>
# **DownloadFileUsingGET**
> byte[] DownloadFileUsingGET (string fileId)

Download a single file

Returns a file with the provided ID, which points to a file meta ID.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DownloadFileUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var fileId = fileId_example;  // string | The unique identifier of the file

            try
            {
                // Download a single file
                byte[] result = apiInstance.DownloadFileUsingGET(fileId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.DownloadFileUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **string**| The unique identifier of the file | 

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="exportfiletospreadsheetsusingpost"></a>
# **ExportFileToSpreadsheetsUsingPOST**
> BaseResponseOfSpreadsheetInfoDto ExportFileToSpreadsheetsUsingPOST (string fileId, ExportFileDto exportFileDto)

Export a file to spreadsheets

Exports the file ID identified in the path to the spreadsheet identified by the provided URL. If the URL string is empty, creates and returns a new spreadsheet and its sheet IDs.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ExportFileToSpreadsheetsUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var fileId = fileId_example;  // string | The unique identifier of the file
            var exportFileDto = new ExportFileDto(); // ExportFileDto | The representation of the file to export

            try
            {
                // Export a file to spreadsheets
                BaseResponseOfSpreadsheetInfoDto result = apiInstance.ExportFileToSpreadsheetsUsingPOST(fileId, exportFileDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.ExportFileToSpreadsheetsUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **string**| The unique identifier of the file | 
 **exportFileDto** | [**ExportFileDto**](ExportFileDto.md)| The representation of the file to export | 

### Return type

[**BaseResponseOfSpreadsheetInfoDto**](BaseResponseOfSpreadsheetInfoDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="geterrorsusingget"></a>
# **GetErrorsUsingGET**
> PagedResponseOfImportErrorDto GetErrorsUsingGET (string fileId, int? limit = null, string cursor = null, long? offset = null)

Retrieve errors

Returns a paged list of operation errors during the upload, import, or tagging processes for the provided file ID, if they exist. This list is immutable and may be empty if no errors have occurred. If errors exist we recommend fixing them and reimporting your file

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetErrorsUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var fileId = fileId_example;  // string | The unique identifier of the file
            var limit = 56;  // int? | The number of errors to return, from 1 to 50; by default, 50 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve errors
                PagedResponseOfImportErrorDto result = apiInstance.GetErrorsUsingGET(fileId, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.GetErrorsUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **string**| The unique identifier of the file | 
 **limit** | **int?**| The number of errors to return, from 1 to 50; by default, 50 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfImportErrorDto**](PagedResponseOfImportErrorDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getfileusingget"></a>
# **GetFileUsingGET**
> BaseResponseOfFileMetaDto GetFileUsingGET (string fileId)

Retrieve a single file

Returns the file meta that matches the provided ID, or a 404 if an associated file can't be found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetFileUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var fileId = fileId_example;  // string | The unique identifier of the file

            try
            {
                // Retrieve a single file
                BaseResponseOfFileMetaDto result = apiInstance.GetFileUsingGET(fileId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.GetFileUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileId** | **string**| The unique identifier of the file | 

### Return type

[**BaseResponseOfFileMetaDto**](BaseResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getfilesusingget"></a>
# **GetFilesUsingGET**
> PagedResponseOfFileMetaDto GetFilesUsingGET (string tableId, int? limit = null, string cursor = null, long? offset = null, string sortOrder = null, string sortBy = null, string searchText = null)

Retrieve a list of files

Returns a paged list of all files associated with the provided table ID, as well as metadata associated with each file.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetFilesUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var tableId = tableId_example;  // string | The unique table identifier associated with this file
            var limit = 56;  // int? | The number of files to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 
            var sortOrder = sortOrder_example;  // string | The sort order for the files being returned (optional) 
            var sortBy = sortBy_example;  // string | The column to use the sort order on (optional) 
            var searchText = searchText_example;  // string | The text to filter the results upon; matching the file name (optional) 

            try
            {
                // Retrieve a list of files
                PagedResponseOfFileMetaDto result = apiInstance.GetFilesUsingGET(tableId, limit, cursor, offset, sortOrder, sortBy, searchText);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.GetFilesUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **string**| The unique table identifier associated with this file | 
 **limit** | **int?**| The number of files to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 
 **sortOrder** | **string**| The sort order for the files being returned | [optional] 
 **sortBy** | **string**| The column to use the sort order on | [optional] 
 **searchText** | **string**| The text to filter the results upon; matching the file name | [optional] 

### Return type

[**PagedResponseOfFileMetaDto**](PagedResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="uploadfileusingpost"></a>
# **UploadFileUsingPOST**
> BaseResponseOfFileMetaDto UploadFileUsingPOST (string tableId, System.IO.Stream file = null, string name = null, string url = null, string source = null, string delimiter = null)

Upload a single file

Accepts CSV, TSV, or JSON files, or a ZIP file that contains a single CSV, TSV, or JSON file. If a ZIP, it must contain a CSV, TSV, or JSON file, and the name of the CSV, TSV, or JSON file is also used with the imported file. Downloading this file again downloads the source. Note that all files uploaded must have a .csv, .tsv, or .json extension. JSON files are expected to have a single JSON record per line; a JSON file is a series of JSON objects delimited by a newline character.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UploadFileUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var tableId = tableId_example;  // string | The unique table identifier associated with this file
            var file = new System.IO.Stream(); // System.IO.Stream | The physical file to upload (optional) 
            var name = name_example;  // string | No longer in use, here to ensure backwards compatibility (optional) 
            var url = url_example;  // string | No longer in use, here to ensure backwards compatibility (optional) 
            var source = source_example;  // string | The data source to associate with the file, no more than 255 characters. This field is not in use; it only keeps track of the source (optional) 
            var delimiter = delimiter_example;  // string | The character to use as a delimiter within the file to separate one field from another.  The default is comma (optional) 

            try
            {
                // Upload a single file
                BaseResponseOfFileMetaDto result = apiInstance.UploadFileUsingPOST(tableId, file, name, url, source, delimiter);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.UploadFileUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **string**| The unique table identifier associated with this file | 
 **file** | **System.IO.Stream**| The physical file to upload | [optional] 
 **name** | **string**| No longer in use, here to ensure backwards compatibility | [optional] 
 **url** | **string**| No longer in use, here to ensure backwards compatibility | [optional] 
 **source** | **string**| The data source to associate with the file, no more than 255 characters. This field is not in use; it only keeps track of the source | [optional] 
 **delimiter** | **string**| The character to use as a delimiter within the file to separate one field from another.  The default is comma | [optional] 

### Return type

[**BaseResponseOfFileMetaDto**](BaseResponseOfFileMetaDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="validatefilenameusingget"></a>
# **ValidateFilenameUsingGET**
> BaseResponseOfstring ValidateFilenameUsingGET (string tableId, string filename)

Validate whether a file with the filename can be uploaded to the table

If the filename is valid, this returns 200. If the table already has a file with the same name, this returns 409. If the user isn't allowed to read the table, or if the table isn't found, this returns 404.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ValidateFilenameUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FileManagementApi();
            var tableId = tableId_example;  // string | The ID of the table to upload the file to
            var filename = filename_example;  // string | The name of the file to upload

            try
            {
                // Validate whether a file with the filename can be uploaded to the table
                BaseResponseOfstring result = apiInstance.ValidateFilenameUsingGET(tableId, filename);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FileManagementApi.ValidateFilenameUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **string**| The ID of the table to upload the file to | 
 **filename** | **string**| The name of the file to upload | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

