# IO.Swagger.Api.FolderManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreateFolderUsingPOST**](FolderManagementApi.md#createfolderusingpost) | **POST** /api/v1/folder | Create a new folder
[**DeleteFolderUsingDELETE**](FolderManagementApi.md#deletefolderusingdelete) | **DELETE** /api/v1/folder/{folderId} | Delete a single folder
[**GetFolderUsingGET**](FolderManagementApi.md#getfolderusingget) | **GET** /api/v1/folder/{folderId} | Retrieve a single folder
[**ListChildrenUsingGET**](FolderManagementApi.md#listchildrenusingget) | **GET** /api/v1/folder/{folderId}/children | Retrieve list of folder contents
[**ListFoldersUsingGET**](FolderManagementApi.md#listfoldersusingget) | **GET** /api/v1/folder | Retrieve a list of folders
[**SearchUsingGET**](FolderManagementApi.md#searchusingget) | **GET** /api/v1/entity | Search
[**SetChildrenUsingPOST**](FolderManagementApi.md#setchildrenusingpost) | **POST** /api/v1/folder/{folderId}/children | Move content into a folder
[**UpdateFolderUsingPUT**](FolderManagementApi.md#updatefolderusingput) | **PUT** /api/v1/folder/{folderId} | Update a single folder


<a name="createfolderusingpost"></a>
# **CreateFolderUsingPOST**
> BaseResponseOfFolderDto CreateFolderUsingPOST (FolderDto folderDto)

Create a new folder

Creates a folder using the provided information and returns the folder meta.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateFolderUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var folderDto = new FolderDto(); // FolderDto | The representation of the folder to create

            try
            {
                // Create a new folder
                BaseResponseOfFolderDto result = apiInstance.CreateFolderUsingPOST(folderDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.CreateFolderUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderDto** | [**FolderDto**](FolderDto.md)| The representation of the folder to create | 

### Return type

[**BaseResponseOfFolderDto**](BaseResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="deletefolderusingdelete"></a>
# **DeleteFolderUsingDELETE**
> BaseResponseOfstring DeleteFolderUsingDELETE (string folderId)

Delete a single folder

Deletes the folder with the provided ID.  If the folder is not found, this is a no-op. <b>All files and sub-folders are also recursively deleted.</b>

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteFolderUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var folderId = folderId_example;  // string | The unique identifier of the folder

            try
            {
                // Delete a single folder
                BaseResponseOfstring result = apiInstance.DeleteFolderUsingDELETE(folderId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.DeleteFolderUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **string**| The unique identifier of the folder | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getfolderusingget"></a>
# **GetFolderUsingGET**
> BaseResponseOfFolderDto GetFolderUsingGET (string folderId)

Retrieve a single folder

Returns a folder with the provided ID, or a 404 if no matching folder is found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetFolderUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var folderId = folderId_example;  // string | The unique identifier of the folder

            try
            {
                // Retrieve a single folder
                BaseResponseOfFolderDto result = apiInstance.GetFolderUsingGET(folderId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.GetFolderUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **string**| The unique identifier of the folder | 

### Return type

[**BaseResponseOfFolderDto**](BaseResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listchildrenusingget"></a>
# **ListChildrenUsingGET**
> PagedResponseOfFolderableDto ListChildrenUsingGET (string folderId, int? limit = null, string cursor = null, long? offset = null)

Retrieve list of folder contents

Returns a paged list of all children whose parent ID matches the provided folder ID.  If the folder ID in the path is the literal 'null' value, returns a list of all entities with no parent.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListChildrenUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var folderId = folderId_example;  // string | The unique identifier of the folder
            var limit = 56;  // int? | The number of folders to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve list of folder contents
                PagedResponseOfFolderableDto result = apiInstance.ListChildrenUsingGET(folderId, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.ListChildrenUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **string**| The unique identifier of the folder | 
 **limit** | **int?**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfFolderableDto**](PagedResponseOfFolderableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listfoldersusingget"></a>
# **ListFoldersUsingGET**
> PagedResponseOfFolderDto ListFoldersUsingGET (int? limit = null, string cursor = null, long? offset = null)

Retrieve a list of folders

Returns a paged list of all folders associated with the workspace.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListFoldersUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var limit = 56;  // int? | The number of folders to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve a list of folders
                PagedResponseOfFolderDto result = apiInstance.ListFoldersUsingGET(limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.ListFoldersUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **int?**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfFolderDto**](PagedResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="searchusingget"></a>
# **SearchUsingGET**
> PagedResponseOfFolderableDto SearchUsingGET (string name = null, string description = null, List<int?> type = null, int? limit = null, string cursor = null, long? offset = null)

Search

Returns a list of all entities that match the provided criteria. Both name and description are fuzzy matches; they match _any_ entity that contains the provided string. The type is used to filter results based on the provided type of entity.  The consumer must have READ access on all returned entities.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class SearchUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var name = name_example;  // string | The name to use when fuzzy-matching entities (optional) 
            var description = description_example;  // string | The description to use when fuzzy-matching entities (optional) 
            var type = new List<int?>(); // List<int?> | To limit the scope, the type of entity to return in the results (optional) 
            var limit = 56;  // int? | The number of folders to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Search
                PagedResponseOfFolderableDto result = apiInstance.SearchUsingGET(name, description, type, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.SearchUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**| The name to use when fuzzy-matching entities | [optional] 
 **description** | **string**| The description to use when fuzzy-matching entities | [optional] 
 **type** | [**List<int?>**](int?.md)| To limit the scope, the type of entity to return in the results | [optional] 
 **limit** | **int?**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfFolderableDto**](PagedResponseOfFolderableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="setchildrenusingpost"></a>
# **SetChildrenUsingPOST**
> BaseResponseOfCollectionOfFolderableDto SetChildrenUsingPOST (string folderId, List<FolderableDto> children)

Move content into a folder

Sets the children of a folder using the entities' types and IDs provided in the body. If the entities previously resided under a folder, including the root, they move to the folder with the provided ID. If the provided ID is 'null', the entities move to the root folder.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class SetChildrenUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var folderId = folderId_example;  // string | The unique identifier of the folder
            var children = new List<FolderableDto>(); // List<FolderableDto> | The representation of the entities to drop into the folder

            try
            {
                // Move content into a folder
                BaseResponseOfCollectionOfFolderableDto result = apiInstance.SetChildrenUsingPOST(folderId, children);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.SetChildrenUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **string**| The unique identifier of the folder | 
 **children** | [**List<FolderableDto>**](FolderableDto.md)| The representation of the entities to drop into the folder | 

### Return type

[**BaseResponseOfCollectionOfFolderableDto**](BaseResponseOfCollectionOfFolderableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatefolderusingput"></a>
# **UpdateFolderUsingPUT**
> BaseResponseOfFolderDto UpdateFolderUsingPUT (string folderId, FolderDto folderDto)

Update a single folder

Updates the folder that matches the provided ID with the details provided in the body.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateFolderUsingPUTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new FolderManagementApi();
            var folderId = folderId_example;  // string | The unique identifier of the folder
            var folderDto = new FolderDto(); // FolderDto | The representation of the folder to update

            try
            {
                // Update a single folder
                BaseResponseOfFolderDto result = apiInstance.UpdateFolderUsingPUT(folderId, folderDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FolderManagementApi.UpdateFolderUsingPUT: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **folderId** | **string**| The unique identifier of the folder | 
 **folderDto** | [**FolderDto**](FolderDto.md)| The representation of the folder to update | 

### Return type

[**BaseResponseOfFolderDto**](BaseResponseOfFolderDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

