# IO.Swagger.Api.ParameterManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreateParameterUsingPOST**](ParameterManagementApi.md#createparameterusingpost) | **POST** /api/v1/parameter | Create parameter
[**DeleteParameterUsingDELETE**](ParameterManagementApi.md#deleteparameterusingdelete) | **DELETE** /api/v1/parameter/{parameterId} | Delete Parameter
[**GetParameterUsingGET**](ParameterManagementApi.md#getparameterusingget) | **GET** /api/v1/parameter/{parameterId} | Get Parameter
[**ListParametersUsingGET**](ParameterManagementApi.md#listparametersusingget) | **GET** /api/v1/parameter | Get Parameters
[**UpdateParameterUsingPUT**](ParameterManagementApi.md#updateparameterusingput) | **PUT** /api/v1/parameter/{parameterId} | Update Parameter


<a name="createparameterusingpost"></a>
# **CreateParameterUsingPOST**
> BaseResponseOfGlobalParameterDto CreateParameterUsingPOST (GlobalParameterDto parameterDto)

Create parameter

Creates a parameter.  If there is a parameter with the same ID, a 409 is returned.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateParameterUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ParameterManagementApi();
            var parameterDto = new GlobalParameterDto(); // GlobalParameterDto | The representation of the parameter to create

            try
            {
                // Create parameter
                BaseResponseOfGlobalParameterDto result = apiInstance.CreateParameterUsingPOST(parameterDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ParameterManagementApi.CreateParameterUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterDto** | [**GlobalParameterDto**](GlobalParameterDto.md)| The representation of the parameter to create | 

### Return type

[**BaseResponseOfGlobalParameterDto**](BaseResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="deleteparameterusingdelete"></a>
# **DeleteParameterUsingDELETE**
> BaseResponseOfstring DeleteParameterUsingDELETE (string parameterId)

Delete Parameter

Deletes the parameter with the provided parameter ID.  If the parameter is not found, this is a no-op.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteParameterUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ParameterManagementApi();
            var parameterId = parameterId_example;  // string | The unique identifier of the parameter

            try
            {
                // Delete Parameter
                BaseResponseOfstring result = apiInstance.DeleteParameterUsingDELETE(parameterId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ParameterManagementApi.DeleteParameterUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterId** | **string**| The unique identifier of the parameter | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getparameterusingget"></a>
# **GetParameterUsingGET**
> BaseResponseOfGlobalParameterDto GetParameterUsingGET (string parameterId)

Get Parameter

Returns a parameter matching the provided parameter ID.  If no matching entity can be found, a 404 status is returned.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetParameterUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ParameterManagementApi();
            var parameterId = parameterId_example;  // string | The unique identifier of the parameter

            try
            {
                // Get Parameter
                BaseResponseOfGlobalParameterDto result = apiInstance.GetParameterUsingGET(parameterId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ParameterManagementApi.GetParameterUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterId** | **string**| The unique identifier of the parameter | 

### Return type

[**BaseResponseOfGlobalParameterDto**](BaseResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listparametersusingget"></a>
# **ListParametersUsingGET**
> PagedResponseOfGlobalParameterDto ListParametersUsingGET (int? limit = null, string cursor = null, long? offset = null)

Get Parameters

Returns a list of all parameters associated with the workspace.  By default, these parameters are ordered by their names in ascending order.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListParametersUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ParameterManagementApi();
            var limit = 56;  // int? | The number of parameters to return, must be between 1 and 1000, will default to 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included the limit is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, must be greater than or equal to 0, will default to 0 (optional) 

            try
            {
                // Get Parameters
                PagedResponseOfGlobalParameterDto result = apiInstance.ListParametersUsingGET(limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ParameterManagementApi.ListParametersUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **int?**| The number of parameters to return, must be between 1 and 1000, will default to 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included the limit is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, must be greater than or equal to 0, will default to 0 | [optional] 

### Return type

[**PagedResponseOfGlobalParameterDto**](PagedResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updateparameterusingput"></a>
# **UpdateParameterUsingPUT**
> BaseResponseOfGlobalParameterDto UpdateParameterUsingPUT (string parameterId, GlobalParameterDto parameterDto)

Update Parameter

Updates the parameter matching the provided ID in the provided payload.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateParameterUsingPUTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new ParameterManagementApi();
            var parameterId = parameterId_example;  // string | The unique identifier of the parameter
            var parameterDto = new GlobalParameterDto(); // GlobalParameterDto | The representation of the parameter to update

            try
            {
                // Update Parameter
                BaseResponseOfGlobalParameterDto result = apiInstance.UpdateParameterUsingPUT(parameterId, parameterDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ParameterManagementApi.UpdateParameterUsingPUT: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **parameterId** | **string**| The unique identifier of the parameter | 
 **parameterDto** | [**GlobalParameterDto**](GlobalParameterDto.md)| The representation of the parameter to update | 

### Return type

[**BaseResponseOfGlobalParameterDto**](BaseResponseOfGlobalParameterDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

