# IO.Swagger.Api.PivotViewManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreatePivotViewUsingPOST**](PivotViewManagementApi.md#createpivotviewusingpost) | **POST** /api/v1/pivotview | Create a new pivot view
[**DeletePivotViewUsingDELETE**](PivotViewManagementApi.md#deletepivotviewusingdelete) | **DELETE** /api/v1/pivotview/{pivotViewId} | Delete a single pivot view
[**DownloadPivotViewTokenUsingGET**](PivotViewManagementApi.md#downloadpivotviewtokenusingget) | **GET** /api/v1/pivotview/{pivotViewId}/token | This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
[**DownloadPivotViewUsingGET**](PivotViewManagementApi.md#downloadpivotviewusingget) | **GET** /api/v1/pivotview/{pivotViewId}/download | This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
[**GetPivotViewUsingGET**](PivotViewManagementApi.md#getpivotviewusingget) | **GET** /api/v1/pivotview/{pivotViewId} | Retrieve a single pivot view
[**ListPivotViewsUsingGET**](PivotViewManagementApi.md#listpivotviewsusingget) | **GET** /api/v1/pivotview | Retrieve a list of pivot views
[**UpdatePivotViewUsingPUT**](PivotViewManagementApi.md#updatepivotviewusingput) | **PUT** /api/v1/pivotview/{pivotViewId} | Update a single pivot view


<a name="createpivotviewusingpost"></a>
# **CreatePivotViewUsingPOST**
> BaseResponseOfPivotViewDto CreatePivotViewUsingPOST (PivotViewDto pivotViewDto)

Create a new pivot view

Creates a view from the provided information. Currently, persists the provided `additionalMetadata` field, which can store an arbitrary JSON definition of a pivot table view. This pivot table must be associated with a query, and can optionally be associated with a query result. When a query is deleted, its associated views are also deleted.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreatePivotViewUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new PivotViewManagementApi();
            var pivotViewDto = new PivotViewDto(); // PivotViewDto | The representation of the view to create

            try
            {
                // Create a new pivot view
                BaseResponseOfPivotViewDto result = apiInstance.CreatePivotViewUsingPOST(pivotViewDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PivotViewManagementApi.CreatePivotViewUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewDto** | [**PivotViewDto**](PivotViewDto.md)| The representation of the view to create | 

### Return type

[**BaseResponseOfPivotViewDto**](BaseResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="deletepivotviewusingdelete"></a>
# **DeletePivotViewUsingDELETE**
> BaseResponseOfstring DeletePivotViewUsingDELETE (string pivotViewId)

Delete a single pivot view

Deletes a view that matches the provided ID.  This is an administrative method and should be assumed a hard-delete, given no capability to restore a deleted view is available.  A no-op if no such view exists.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeletePivotViewUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new PivotViewManagementApi();
            var pivotViewId = pivotViewId_example;  // string | The unique identifier of the pivot view

            try
            {
                // Delete a single pivot view
                BaseResponseOfstring result = apiInstance.DeletePivotViewUsingDELETE(pivotViewId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PivotViewManagementApi.DeletePivotViewUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **string**| The unique identifier of the pivot view | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="downloadpivotviewtokenusingget"></a>
# **DownloadPivotViewTokenUsingGET**
> BaseResponseOfTokenDto DownloadPivotViewTokenUsingGET (string pivotViewId)

This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DownloadPivotViewTokenUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new PivotViewManagementApi();
            var pivotViewId = pivotViewId_example;  // string | The unique identifier of the pivot view

            try
            {
                // This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
                BaseResponseOfTokenDto result = apiInstance.DownloadPivotViewTokenUsingGET(pivotViewId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PivotViewManagementApi.DownloadPivotViewTokenUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **string**| The unique identifier of the pivot view | 

### Return type

[**BaseResponseOfTokenDto**](BaseResponseOfTokenDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="downloadpivotviewusingget"></a>
# **DownloadPivotViewUsingGET**
> byte[] DownloadPivotViewUsingGET (string pivotViewId)

This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DownloadPivotViewUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new PivotViewManagementApi();
            var pivotViewId = pivotViewId_example;  // string | The unique identifier of the pivot view

            try
            {
                // This endpoint is deprecated. It not longer functions as intended, as pivotingquery results is now handled by cross tab queries. This endpoint will be removedon September 1, 2020.
                byte[] result = apiInstance.DownloadPivotViewUsingGET(pivotViewId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PivotViewManagementApi.DownloadPivotViewUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **string**| The unique identifier of the pivot view | 

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getpivotviewusingget"></a>
# **GetPivotViewUsingGET**
> BaseResponseOfPivotViewDto GetPivotViewUsingGET (string pivotViewId)

Retrieve a single pivot view

Returns a view with the provided ID, or a 404 if no view matches the ID.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetPivotViewUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new PivotViewManagementApi();
            var pivotViewId = pivotViewId_example;  // string | The unique identifier of the pivot view

            try
            {
                // Retrieve a single pivot view
                BaseResponseOfPivotViewDto result = apiInstance.GetPivotViewUsingGET(pivotViewId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PivotViewManagementApi.GetPivotViewUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **string**| The unique identifier of the pivot view | 

### Return type

[**BaseResponseOfPivotViewDto**](BaseResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listpivotviewsusingget"></a>
# **ListPivotViewsUsingGET**
> PagedResponseOfPivotViewDto ListPivotViewsUsingGET (string queryId, int? limit = null, string cursor = null, long? offset = null)

Retrieve a list of pivot views

Returns a paged list of views in the workspace of the request. If queryId is provided, the results are limited to only views associated with the query ID.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListPivotViewsUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new PivotViewManagementApi();
            var queryId = queryId_example;  // string | The unique query identifier to filter the views
            var limit = 56;  // int? | The number of views to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve a list of pivot views
                PagedResponseOfPivotViewDto result = apiInstance.ListPivotViewsUsingGET(queryId, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PivotViewManagementApi.ListPivotViewsUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **string**| The unique query identifier to filter the views | 
 **limit** | **int?**| The number of views to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfPivotViewDto**](PagedResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatepivotviewusingput"></a>
# **UpdatePivotViewUsingPUT**
> BaseResponseOfPivotViewDto UpdatePivotViewUsingPUT (string pivotViewId, PivotViewDto pivotViewDto)

Update a single pivot view

Updates the view that matches the provided ID with the details provided in the body. The associated query can't be updated, so providing the query ID has no effect.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdatePivotViewUsingPUTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new PivotViewManagementApi();
            var pivotViewId = pivotViewId_example;  // string | The unique identifier of the pivot view
            var pivotViewDto = new PivotViewDto(); // PivotViewDto | The representation of the pivot view to create

            try
            {
                // Update a single pivot view
                BaseResponseOfPivotViewDto result = apiInstance.UpdatePivotViewUsingPUT(pivotViewId, pivotViewDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PivotViewManagementApi.UpdatePivotViewUsingPUT: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **pivotViewId** | **string**| The unique identifier of the pivot view | 
 **pivotViewDto** | [**PivotViewDto**](PivotViewDto.md)| The representation of the pivot view to create | 

### Return type

[**BaseResponseOfPivotViewDto**](BaseResponseOfPivotViewDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

