# IO.Swagger.Api.QueryManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CancelQueryUsingDELETE**](QueryManagementApi.md#cancelqueryusingdelete) | **DELETE** /api/v1/queryresult/{queryResultId} | Cancel a running query
[**CreateQueryUsingPOST**](QueryManagementApi.md#createqueryusingpost) | **POST** /api/v1/query | Create a new query
[**DeleteQueryUsingDELETE**](QueryManagementApi.md#deletequeryusingdelete) | **DELETE** /api/v1/query/{queryId} | Delete a single query
[**DownloadQueryResultUsingGET**](QueryManagementApi.md#downloadqueryresultusingget) | **GET** /api/v1/queryresult/{queryResultId}/download | Download a query result
[**ExportQueryResultToSpreadsheetsUsingPOST**](QueryManagementApi.md#exportqueryresulttospreadsheetsusingpost) | **POST** /api/v1/queryresult/{queryResultId}/export | Export query result to spreadsheets
[**GetDependenciesUsingGET**](QueryManagementApi.md#getdependenciesusingget) | **GET** /api/v1/query/{queryId}/dependencies | Retrieve dependencies
[**GetQueryColumnDataUsingPOST**](QueryManagementApi.md#getquerycolumndatausingpost) | **POST** /api/v1/query/data | Retrieve query column data
[**GetQueryResultUsingGET**](QueryManagementApi.md#getqueryresultusingget) | **GET** /api/v1/queryresult/{queryResultId} | Retrieve a single query result
[**GetQueryUsingGET**](QueryManagementApi.md#getqueryusingget) | **GET** /api/v1/query/{queryId} | Retrieve a single query
[**GetTablesDependentOnQueryUsingGET**](QueryManagementApi.md#gettablesdependentonqueryusingget) | **GET** /api/v1/query/{queryId}/dependents | Retrieve a list of dependents
[**IsQueryValidUsingPOST**](QueryManagementApi.md#isqueryvalidusingpost) | **POST** /api/v1/query/validation | Parses the query to determine if it is valid
[**ListQueriesUsingGET**](QueryManagementApi.md#listqueriesusingget) | **GET** /api/v1/query | Retrieve list of queries
[**ListQueryResultsUsingGET**](QueryManagementApi.md#listqueryresultsusingget) | **GET** /api/v1/queryresult | Retrieve a list of query results
[**PreviewQueryUsingPOST**](QueryManagementApi.md#previewqueryusingpost) | **POST** /api/v1/query/preview/{tableId} | Preview a query
[**RunQueryUsingPOST**](QueryManagementApi.md#runqueryusingpost) | **POST** /api/v1/queryresult | Execute a query
[**UpdateQueryUsingPUT**](QueryManagementApi.md#updatequeryusingput) | **PUT** /api/v1/query/{queryId} | Update a single query


<a name="cancelqueryusingdelete"></a>
# **CancelQueryUsingDELETE**
> BaseResponseOfQueryResultDto CancelQueryUsingDELETE (string queryResultId)

Cancel a running query

Cancels a running query based on the provided result ID, and returns a cancelled result unless the query's already in a COMPLETED state.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CancelQueryUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryResultId = queryResultId_example;  // string | The unique identifier of the query result

            try
            {
                // Cancel a running query
                BaseResponseOfQueryResultDto result = apiInstance.CancelQueryUsingDELETE(queryResultId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.CancelQueryUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **string**| The unique identifier of the query result | 

### Return type

[**BaseResponseOfQueryResultDto**](BaseResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="createqueryusingpost"></a>
# **CreateQueryUsingPOST**
> BaseResponseOfQueryDto CreateQueryUsingPOST (QueryDto queryDto)

Create a new query

Creates a query object and validates full permissions to ensure the requestor has access to all data sources being queried. This endpoint _doesn't_ execute the query; to execute, call the POST /queryresult method.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateQueryUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryDto = new QueryDto(); // QueryDto | The representation of the query to create

            try
            {
                // Create a new query
                BaseResponseOfQueryDto result = apiInstance.CreateQueryUsingPOST(queryDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.CreateQueryUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryDto** | [**QueryDto**](QueryDto.md)| The representation of the query to create | 

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="deletequeryusingdelete"></a>
# **DeleteQueryUsingDELETE**
> BaseResponseOfstring DeleteQueryUsingDELETE (string queryId)

Delete a single query

Deletes the query that matches the provided ID. If no such query is found, this is a no-op.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteQueryUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryId = queryId_example;  // string | The unique identifier of the query

            try
            {
                // Delete a single query
                BaseResponseOfstring result = apiInstance.DeleteQueryUsingDELETE(queryId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.DeleteQueryUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **string**| The unique identifier of the query | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="downloadqueryresultusingget"></a>
# **DownloadQueryResultUsingGET**
> byte[] DownloadQueryResultUsingGET (string queryResultId)

Download a query result

Uses the Token Management API to create a token with the query result ID, which it then uses to download a CSV file of the query results.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DownloadQueryResultUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryResultId = queryResultId_example;  // string | The unique identifier of the query result

            try
            {
                // Download a query result
                byte[] result = apiInstance.DownloadQueryResultUsingGET(queryResultId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.DownloadQueryResultUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **string**| The unique identifier of the query result | 

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="exportqueryresulttospreadsheetsusingpost"></a>
# **ExportQueryResultToSpreadsheetsUsingPOST**
> BaseResponseOfstring ExportQueryResultToSpreadsheetsUsingPOST (string queryResultId, ExportQueryResultDto dto)

Export query result to spreadsheets

Exports a query result with the provided ID to Spreadsheets. To determine where to export the results, the request body should include a URL copied and pasted from the Spreadsheets UI. Returns a 404 if no matching query result is found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ExportQueryResultToSpreadsheetsUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryResultId = queryResultId_example;  // string | The unique identifier of the query result
            var dto = new ExportQueryResultDto(); // ExportQueryResultDto | The representation of the export query result

            try
            {
                // Export query result to spreadsheets
                BaseResponseOfstring result = apiInstance.ExportQueryResultToSpreadsheetsUsingPOST(queryResultId, dto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.ExportQueryResultToSpreadsheetsUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **string**| The unique identifier of the query result | 
 **dto** | [**ExportQueryResultDto**](ExportQueryResultDto.md)| The representation of the export query result | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getdependenciesusingget"></a>
# **GetDependenciesUsingGET**
> PagedResponseOfTableDto GetDependenciesUsingGET (string queryId, int? limit = null, string cursor = null, long? offset = null)

Retrieve dependencies

Returns an unordered collection of all tables the matching query uses as datasources, including any shared tables outside of this OAuth token's workspace. The endpoint verifies the user has read permissions on the query, but _not_ on the tables returned.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetDependenciesUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryId = queryId_example;  // string | The unique identifier of the query
            var limit = 56;  // int? | The number of dependencies to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve dependencies
                PagedResponseOfTableDto result = apiInstance.GetDependenciesUsingGET(queryId, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.GetDependenciesUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **string**| The unique identifier of the query | 
 **limit** | **int?**| The number of dependencies to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfTableDto**](PagedResponseOfTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getquerycolumndatausingpost"></a>
# **GetQueryColumnDataUsingPOST**
> BaseResponseOfQueryColumnDataDto GetQueryColumnDataUsingPOST (QueryTextDto queryTextDto)

Retrieve query column data

Returns a QueryColumnDataDto representing the column data for the given query text. If the query isn't valid, returns a 400.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetQueryColumnDataUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryTextDto = new QueryTextDto(); // QueryTextDto | The query text to parse, up to 30000 characters; must not be null or empty

            try
            {
                // Retrieve query column data
                BaseResponseOfQueryColumnDataDto result = apiInstance.GetQueryColumnDataUsingPOST(queryTextDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.GetQueryColumnDataUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryTextDto** | [**QueryTextDto**](QueryTextDto.md)| The query text to parse, up to 30000 characters; must not be null or empty | 

### Return type

[**BaseResponseOfQueryColumnDataDto**](BaseResponseOfQueryColumnDataDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getqueryresultusingget"></a>
# **GetQueryResultUsingGET**
> BaseResponseOfQueryResultDto GetQueryResultUsingGET (string queryResultId)

Retrieve a single query result

Returns a single query result that matches the provided ID, or a 404 if no such query result is found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetQueryResultUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryResultId = queryResultId_example;  // string | The unique identifier of the query result

            try
            {
                // Retrieve a single query result
                BaseResponseOfQueryResultDto result = apiInstance.GetQueryResultUsingGET(queryResultId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.GetQueryResultUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultId** | **string**| The unique identifier of the query result | 

### Return type

[**BaseResponseOfQueryResultDto**](BaseResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getqueryusingget"></a>
# **GetQueryUsingGET**
> BaseResponseOfQueryDto GetQueryUsingGET (string queryId)

Retrieve a single query

Returns a query that matches the provided ID, or a 404 if no matching query is found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetQueryUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryId = queryId_example;  // string | The unique identifier of the query

            try
            {
                // Retrieve a single query
                BaseResponseOfQueryDto result = apiInstance.GetQueryUsingGET(queryId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.GetQueryUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **string**| The unique identifier of the query | 

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="gettablesdependentonqueryusingget"></a>
# **GetTablesDependentOnQueryUsingGET**
> PagedResponseOfTableDto GetTablesDependentOnQueryUsingGET (string queryId, int? limit = null, string cursor = null, long? offset = null)

Retrieve a list of dependents

Returns a list of all tables that use the query with provided ID as a datasource. 

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetTablesDependentOnQueryUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryId = queryId_example;  // string | The unique identifier of the query
            var limit = 56;  // int? | The number of folders to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve a list of dependents
                PagedResponseOfTableDto result = apiInstance.GetTablesDependentOnQueryUsingGET(queryId, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.GetTablesDependentOnQueryUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **string**| The unique identifier of the query | 
 **limit** | **int?**| The number of folders to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfTableDto**](PagedResponseOfTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="isqueryvalidusingpost"></a>
# **IsQueryValidUsingPOST**
> BaseResponseOfQueryDto IsQueryValidUsingPOST (QueryDto queryDto)

Parses the query to determine if it is valid

Returns the provided QueryDto

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class IsQueryValidUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryDto = new QueryDto(); // QueryDto | The representation of the created query

            try
            {
                // Parses the query to determine if it is valid
                BaseResponseOfQueryDto result = apiInstance.IsQueryValidUsingPOST(queryDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.IsQueryValidUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryDto** | [**QueryDto**](QueryDto.md)| The representation of the created query | 

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listqueriesusingget"></a>
# **ListQueriesUsingGET**
> PagedResponseOfQueryDto ListQueriesUsingGET (int? limit = null, string cursor = null, long? offset = null, List<string> ids = null)

Retrieve list of queries

Returns a list of all non-temporary queries associated with the workspace. By default, these queries are ordered by their names, in ascending order.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListQueriesUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var limit = 56;  // int? | The number of queries to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 
            var ids = new List<string>(); // List<string> | A list of ids to filter the returned list by (optional) 

            try
            {
                // Retrieve list of queries
                PagedResponseOfQueryDto result = apiInstance.ListQueriesUsingGET(limit, cursor, offset, ids);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.ListQueriesUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **int?**| The number of queries to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 
 **ids** | [**List<string>**](string.md)| A list of ids to filter the returned list by | [optional] 

### Return type

[**PagedResponseOfQueryDto**](PagedResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listqueryresultsusingget"></a>
# **ListQueryResultsUsingGET**
> PagedResponseOfQueryResultDto ListQueryResultsUsingGET (string queryId = null, string cursor = null, int? limit = null, long? offset = null)

Retrieve a list of query results

Returns a paged list of query results that match the provided query ID, or an empty list if no matching query is found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListQueryResultsUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryId = queryId_example;  // string | The unique identifier of the query (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var limit = 56;  // int? | The number of query results to return, from 1 to 1000; by default, 1000 (optional)  (default to 1000)
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional)  (default to 0)

            try
            {
                // Retrieve a list of query results
                PagedResponseOfQueryResultDto result = apiInstance.ListQueryResultsUsingGET(queryId, cursor, limit, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.ListQueryResultsUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **string**| The unique identifier of the query | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **limit** | **int?**| The number of query results to return, from 1 to 1000; by default, 1000 | [optional] [default to 1000]
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] [default to 0]

### Return type

[**PagedResponseOfQueryResultDto**](PagedResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="previewqueryusingpost"></a>
# **PreviewQueryUsingPOST**
> BaseResponseOfQueryDto PreviewQueryUsingPOST (string tableId, int? limit = null, string fileName = null)

Preview a query

Creates a limited scope query object, but does _not_ execute it. The query selects all values against the provided table, up to 10 rows. This endpoint may allow unpermissioned users to preview table data; full permissions to datasources are _not_ validated.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PreviewQueryUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var tableId = tableId_example;  // string | The identifier of the table to query
            var limit = 56;  // int? | The number of rows to return (optional) 
            var fileName = fileName_example;  // string | The name of the file to create (optional) 

            try
            {
                // Preview a query
                BaseResponseOfQueryDto result = apiInstance.PreviewQueryUsingPOST(tableId, limit, fileName);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.PreviewQueryUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **string**| The identifier of the table to query | 
 **limit** | **int?**| The number of rows to return | [optional] 
 **fileName** | **string**| The name of the file to create | [optional] 

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="runqueryusingpost"></a>
# **RunQueryUsingPOST**
> BaseResponseOfQueryResultDto RunQueryUsingPOST (QueryResultDto queryResultDto)

Execute a query

Runs a query and immediately returns a query result entity, which has an ID that can be used to poll the status from the GET /queryresult method. A status of COMPLETED or ERROR indicates the query has completed.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class RunQueryUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryResultDto = new QueryResultDto(); // QueryResultDto | The representation of the created query

            try
            {
                // Execute a query
                BaseResponseOfQueryResultDto result = apiInstance.RunQueryUsingPOST(queryResultDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.RunQueryUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryResultDto** | [**QueryResultDto**](QueryResultDto.md)| The representation of the created query | 

### Return type

[**BaseResponseOfQueryResultDto**](BaseResponseOfQueryResultDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatequeryusingput"></a>
# **UpdateQueryUsingPUT**
> BaseResponseOfQueryDto UpdateQueryUsingPUT (string queryId, QueryDto queryDto)

Update a single query

Updates the query that matches the provided ID with the details provided in the body.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateQueryUsingPUTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new QueryManagementApi();
            var queryId = queryId_example;  // string | The unique identifier of the query
            var queryDto = new QueryDto(); // QueryDto | The representation of the query to update

            try
            {
                // Update a single query
                BaseResponseOfQueryDto result = apiInstance.UpdateQueryUsingPUT(queryId, queryDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling QueryManagementApi.UpdateQueryUsingPUT: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **queryId** | **string**| The unique identifier of the query | 
 **queryDto** | [**QueryDto**](QueryDto.md)| The representation of the query to update | 

### Return type

[**BaseResponseOfQueryDto**](BaseResponseOfQueryDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

