# IO.Swagger.Api.SelectListManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreateSelectListUsingPOST**](SelectListManagementApi.md#createselectlistusingpost) | **POST** /api/v1/selectlist | Create a new select list
[**DeleteUsingDELETE**](SelectListManagementApi.md#deleteusingdelete) | **DELETE** /api/v1/selectlist/{selectListId} | Delete a single select list
[**GetSelectListUsingGET**](SelectListManagementApi.md#getselectlistusingget) | **GET** /api/v1/selectlist/{selectListId} | Retrieve a single select list
[**ListSelectListsUsingGET**](SelectListManagementApi.md#listselectlistsusingget) | **GET** /api/v1/selectlist | Retrieve a list of select lists
[**UpdateSelectListUsingPUT**](SelectListManagementApi.md#updateselectlistusingput) | **PUT** /api/v1/selectlist/{selectListId} | Update a single select list


<a name="createselectlistusingpost"></a>
# **CreateSelectListUsingPOST**
> BaseResponseOfSelectListDto CreateSelectListUsingPOST (SelectListDto selectListDto)

Create a new select list

Creates a select list using the provided information and returns the select list meta.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateSelectListUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SelectListManagementApi();
            var selectListDto = new SelectListDto(); // SelectListDto | The representation of the select list to create

            try
            {
                // Create a new select list
                BaseResponseOfSelectListDto result = apiInstance.CreateSelectListUsingPOST(selectListDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SelectListManagementApi.CreateSelectListUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListDto** | [**SelectListDto**](SelectListDto.md)| The representation of the select list to create | 

### Return type

[**BaseResponseOfSelectListDto**](BaseResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="deleteusingdelete"></a>
# **DeleteUsingDELETE**
> BaseResponseOfstring DeleteUsingDELETE (string selectListId)

Delete a single select list

Deletes a select list with the provided ID. If no such select list exists, this is a no-op.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SelectListManagementApi();
            var selectListId = selectListId_example;  // string | The unique identifier of the select list

            try
            {
                // Delete a single select list
                BaseResponseOfstring result = apiInstance.DeleteUsingDELETE(selectListId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SelectListManagementApi.DeleteUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListId** | **string**| The unique identifier of the select list | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getselectlistusingget"></a>
# **GetSelectListUsingGET**
> BaseResponseOfSelectListDto GetSelectListUsingGET (string selectListId)

Retrieve a single select list

Returns a select list that matches the provided ID, or a 404 if no matching select list is found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSelectListUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SelectListManagementApi();
            var selectListId = selectListId_example;  // string | The unique identifier of the select list

            try
            {
                // Retrieve a single select list
                BaseResponseOfSelectListDto result = apiInstance.GetSelectListUsingGET(selectListId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SelectListManagementApi.GetSelectListUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListId** | **string**| The unique identifier of the select list | 

### Return type

[**BaseResponseOfSelectListDto**](BaseResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listselectlistsusingget"></a>
# **ListSelectListsUsingGET**
> PagedResponseOfSelectListDto ListSelectListsUsingGET (int? limit = null, string cursor = null, long? offset = null)

Retrieve a list of select lists

Returns a list of select lists associated with the workspace.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListSelectListsUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SelectListManagementApi();
            var limit = 56;  // int? | The number of select lists to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve a list of select lists
                PagedResponseOfSelectListDto result = apiInstance.ListSelectListsUsingGET(limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SelectListManagementApi.ListSelectListsUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **int?**| The number of select lists to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfSelectListDto**](PagedResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updateselectlistusingput"></a>
# **UpdateSelectListUsingPUT**
> BaseResponseOfSelectListDto UpdateSelectListUsingPUT (SelectListDto selectListDto, string selectListId)

Update a single select list

Updates the select list with the provided ID with the details provided  in the body.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateSelectListUsingPUTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SelectListManagementApi();
            var selectListDto = new SelectListDto(); // SelectListDto | The representation of the select list to update
            var selectListId = selectListId_example;  // string | The unique identifier of the select list

            try
            {
                // Update a single select list
                BaseResponseOfSelectListDto result = apiInstance.UpdateSelectListUsingPUT(selectListDto, selectListId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SelectListManagementApi.UpdateSelectListUsingPUT: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **selectListDto** | [**SelectListDto**](SelectListDto.md)| The representation of the select list to update | 
 **selectListId** | **string**| The unique identifier of the select list | 

### Return type

[**BaseResponseOfSelectListDto**](BaseResponseOfSelectListDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

