# IO.Swagger.Api.SharedTableManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreateSharedTableUsingPOST**](SharedTableManagementApi.md#createsharedtableusingpost) | **POST** /api/v1/sharedtable | Create a new shared table
[**DeleteSharedTableUsingDELETE**](SharedTableManagementApi.md#deletesharedtableusingdelete) | **DELETE** /api/v1/sharedtable/{sharedTableId} | Delete a single shared table
[**GetSharedTableUsingGET**](SharedTableManagementApi.md#getsharedtableusingget) | **GET** /api/v1/sharedtable/{sharedTableId} | Retrieve a single shared table
[**ListSharedTablesUsingGET**](SharedTableManagementApi.md#listsharedtablesusingget) | **GET** /api/v1/sharedtable | Retrieve a list of shared tables


<a name="createsharedtableusingpost"></a>
# **CreateSharedTableUsingPOST**
> BaseResponseOfSharedTableDto CreateSharedTableUsingPOST (SharedTableDto sharedTableDto)

Create a new shared table

Creates a shared table instance between the workspace of the request and the workspace provided in the body.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateSharedTableUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SharedTableManagementApi();
            var sharedTableDto = new SharedTableDto(); // SharedTableDto | The representation of the shared table to create

            try
            {
                // Create a new shared table
                BaseResponseOfSharedTableDto result = apiInstance.CreateSharedTableUsingPOST(sharedTableDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SharedTableManagementApi.CreateSharedTableUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sharedTableDto** | [**SharedTableDto**](SharedTableDto.md)| The representation of the shared table to create | 

### Return type

[**BaseResponseOfSharedTableDto**](BaseResponseOfSharedTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="deletesharedtableusingdelete"></a>
# **DeleteSharedTableUsingDELETE**
> BaseResponseOfstring DeleteSharedTableUsingDELETE (string sharedTableId)

Delete a single shared table

Deletes the linkages between the source and destination of a shared table that matches the provided ID; the actual table itself is left intact. If no such shared table exists, this is a no-op.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteSharedTableUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SharedTableManagementApi();
            var sharedTableId = sharedTableId_example;  // string | The unique identifier of the shared table

            try
            {
                // Delete a single shared table
                BaseResponseOfstring result = apiInstance.DeleteSharedTableUsingDELETE(sharedTableId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SharedTableManagementApi.DeleteSharedTableUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sharedTableId** | **string**| The unique identifier of the shared table | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getsharedtableusingget"></a>
# **GetSharedTableUsingGET**
> BaseResponseOfSharedTableDto GetSharedTableUsingGET (string sharedTableId, bool? sharedWithMe = null)

Retrieve a single shared table

Returns a shared table that matches the provided ID, or a 404 if no matching shared table is found.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSharedTableUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SharedTableManagementApi();
            var sharedTableId = sharedTableId_example;  // string | The unique identifier of the shared table
            var sharedWithMe = true;  // bool? | If true, returns a shared table with the provided ID that has been shared _to_—rather than from—the workspace of the request. (optional) 

            try
            {
                // Retrieve a single shared table
                BaseResponseOfSharedTableDto result = apiInstance.GetSharedTableUsingGET(sharedTableId, sharedWithMe);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SharedTableManagementApi.GetSharedTableUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **sharedTableId** | **string**| The unique identifier of the shared table | 
 **sharedWithMe** | **bool?**| If true, returns a shared table with the provided ID that has been shared _to_—rather than from—the workspace of the request. | [optional] 

### Return type

[**BaseResponseOfSharedTableDto**](BaseResponseOfSharedTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listsharedtablesusingget"></a>
# **ListSharedTablesUsingGET**
> PagedResponseOfSharedTableDto ListSharedTablesUsingGET (string tableId = null, bool? sharedWithMe = null, int? limit = null, string cursor = null, long? offset = null)

Retrieve a list of shared tables

Returns a list of shared tables associated with the workspace of the request.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListSharedTablesUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new SharedTableManagementApi();
            var tableId = tableId_example;  // string | The unique table identifier associated with the shared table (optional) 
            var sharedWithMe = true;  // bool? | If true, returns a list of tables that have been shared _to_ it rather than from it. The entities contain both the shared table entity _and_ the table being shared. If true, `tableId` is ignored. (optional) 
            var limit = 56;  // int? | The number of shared files to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve a list of shared tables
                PagedResponseOfSharedTableDto result = apiInstance.ListSharedTablesUsingGET(tableId, sharedWithMe, limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SharedTableManagementApi.ListSharedTablesUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tableId** | **string**| The unique table identifier associated with the shared table | [optional] 
 **sharedWithMe** | **bool?**| If true, returns a list of tables that have been shared _to_ it rather than from it. The entities contain both the shared table entity _and_ the table being shared. If true, &#x60;tableId&#x60; is ignored. | [optional] 
 **limit** | **int?**| The number of shared files to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfSharedTableDto**](PagedResponseOfSharedTableDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

