# IO.Swagger.Model.TableDto
## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**Created** | **DateTime?** | When the entity was created | [optional] 
**DatabaseId** | **string** | The unique identifier of the database where the table resides. | [optional] 
**DatasetUpdated** | **DateTime?** | The last time that the data set for this table was modified. | [optional] 
**Deleted** | **bool?** | This is for backwards compatibility only and will always return false. | [optional] 
**Description** | **string** | May be at most 255 characters in length | [optional] 
**Id** | **string** | The entity&#39;s unique identifier | [optional] 
**IsShared** | **bool?** | A property indicating if this table is shared to any destination. | 
**LastUploaded** | **DateTime?** | Contains the date and time of the last file that was imported into the table. Valuable for determining if the data is stale. | [optional] 
**Name** | **string** | May be at most 150 characters in length | [optional] 
**ParentId** | **string** | If non-null, indicates the parent of this entity. Must be modified through the folder api. | [optional] 
**_ReadOnly** | **bool?** | Indicates if this table is readonly in the account receiving this table. If so, any attempt to edit the table will fail. | [optional] 
**TableSchema** | [**TableSchema**](TableSchema.md) | The schema to apply | [optional] 
**Type** | **string** | The type of table | [optional] 
**UniqueTableConstraints** | [**List&lt;UniqueConstraintDto&gt;**](UniqueConstraintDto.md) | A property indicating the unique constraints on the table. | 
**Updated** | **DateTime?** | When the entity was last updated | [optional] 
**UserId** | **string** | The owner of the entity | [optional] 
**Version** | **long?** | The version of the current representation of the entity | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)

