# IO.Swagger.Api.TagManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreateTagUsingPOST**](TagManagementApi.md#createtagusingpost) | **POST** /api/v1/tag | Create a new tag
[**DeleteTagUsingDELETE**](TagManagementApi.md#deletetagusingdelete) | **DELETE** /api/v1/tag/{tagId} | Delete a single tag
[**ListTagsUsingGET**](TagManagementApi.md#listtagsusingget) | **GET** /api/v1/tag | Retrieve a list of tags
[**UpdateTagUsingPUT**](TagManagementApi.md#updatetagusingput) | **PUT** /api/v1/tag/{tagId} | Update a single tag


<a name="createtagusingpost"></a>
# **CreateTagUsingPOST**
> BaseResponseOfTagDto CreateTagUsingPOST (TagDto tagDto)

Create a new tag

Creates a tag. If another tag already has the same key, returns a 409. There is a limit of 300 values for a tag.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateTagUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new TagManagementApi();
            var tagDto = new TagDto(); // TagDto | The representation of the tag to create

            try
            {
                // Create a new tag
                BaseResponseOfTagDto result = apiInstance.CreateTagUsingPOST(tagDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagManagementApi.CreateTagUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tagDto** | [**TagDto**](TagDto.md)| The representation of the tag to create | 

### Return type

[**BaseResponseOfTagDto**](BaseResponseOfTagDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="deletetagusingdelete"></a>
# **DeleteTagUsingDELETE**
> BaseResponseOfstring DeleteTagUsingDELETE (string tagId)

Delete a single tag

Deletes the tag with the provided ID. If no such tag is found, this is a no-op.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DeleteTagUsingDELETEExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new TagManagementApi();
            var tagId = tagId_example;  // string | The unique identifier of the tag

            try
            {
                // Delete a single tag
                BaseResponseOfstring result = apiInstance.DeleteTagUsingDELETE(tagId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagManagementApi.DeleteTagUsingDELETE: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tagId** | **string**| The unique identifier of the tag | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="listtagsusingget"></a>
# **ListTagsUsingGET**
> PagedResponseOfTagDto ListTagsUsingGET (int? limit = null, string cursor = null, long? offset = null)

Retrieve a list of tags

Returns a paged list of all tags associated with the workspace of the request.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ListTagsUsingGETExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new TagManagementApi();
            var limit = 56;  // int? | The number of tags to return, from 1 to 1000; by default, 1000 (optional) 
            var cursor = cursor_example;  // string | A paging cursor; if included, `limit` is ignored (optional) 
            var offset = 789;  // long? | The item to start with on the page, greater than or equal to 0; by default, 0 (optional) 

            try
            {
                // Retrieve a list of tags
                PagedResponseOfTagDto result = apiInstance.ListTagsUsingGET(limit, cursor, offset);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagManagementApi.ListTagsUsingGET: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **limit** | **int?**| The number of tags to return, from 1 to 1000; by default, 1000 | [optional] 
 **cursor** | **string**| A paging cursor; if included, &#x60;limit&#x60; is ignored | [optional] 
 **offset** | **long?**| The item to start with on the page, greater than or equal to 0; by default, 0 | [optional] 

### Return type

[**PagedResponseOfTagDto**](PagedResponseOfTagDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatetagusingput"></a>
# **UpdateTagUsingPUT**
> BaseResponseOfTagDto UpdateTagUsingPUT (string tagId, TagDto tagDto)

Update a single tag

Updates the tag that matches the provided ID with the details provided in the body. Ignores the provided key, as keys are immutable once set. There is a limit of 300 values for a tag. 

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateTagUsingPUTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new TagManagementApi();
            var tagId = tagId_example;  // string | The unique identifier of the tag
            var tagDto = new TagDto(); // TagDto | The representation of the tag to update

            try
            {
                // Update a single tag
                BaseResponseOfTagDto result = apiInstance.UpdateTagUsingPUT(tagId, tagDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagManagementApi.UpdateTagUsingPUT: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tagId** | **string**| The unique identifier of the tag | 
 **tagDto** | [**TagDto**](TagDto.md)| The representation of the tag to update | 

### Return type

[**BaseResponseOfTagDto**](BaseResponseOfTagDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

