# IO.Swagger.Api.TokenManagementApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CreateTokenUsingPOST**](TokenManagementApi.md#createtokenusingpost) | **POST** /api/v1/token | Create a new token
[**DownloadFileUsingGET1**](TokenManagementApi.md#downloadfileusingget1) | **GET** /api/v1/token/{tokenId} | Download a single file


<a name="createtokenusingpost"></a>
# **CreateTokenUsingPOST**
> BaseResponseOfTokenDto CreateTokenUsingPOST (TokenDto tokenDto)

Create a new token

Creates a temporary token—valid for only a short period of time—to download a table dataset file or query result, given its ID.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CreateTokenUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new TokenManagementApi();
            var tokenDto = new TokenDto(); // TokenDto | The representation of the token to update

            try
            {
                // Create a new token
                BaseResponseOfTokenDto result = apiInstance.CreateTokenUsingPOST(tokenDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TokenManagementApi.CreateTokenUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tokenDto** | [**TokenDto**](TokenDto.md)| The representation of the token to update | 

### Return type

[**BaseResponseOfTokenDto**](BaseResponseOfTokenDto.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="downloadfileusingget1"></a>
# **DownloadFileUsingGET1**
> byte[] DownloadFileUsingGET1 (string tokenId, string filename = null)

Download a single file

Downloads a table dataset or query result as a file, given its token from the [`Create a new token endpoint`](ref:wdata-createtokenusingpost). If no matching entity is found, returns a 404.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DownloadFileUsingGET1Example
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new TokenManagementApi();
            var tokenId = tokenId_example;  // string | The unique identifier of the token
            var filename = filename_example;  // string | A filename for the download; if included, the default filename is overridden (optional) 

            try
            {
                // Download a single file
                byte[] result = apiInstance.DownloadFileUsingGET1(tokenId, filename);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TokenManagementApi.DownloadFileUsingGET1: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tokenId** | **string**| The unique identifier of the token | 
 **filename** | **string**| A filename for the download; if included, the default filename is overridden | [optional] 

### Return type

**byte[]**

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: *_/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

