# IO.Swagger.Api.UtilitiesApi

All URIs are relative to *https://h.app.wdesk.com/s/wdata/prep*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ParseDateUsingPOST**](UtilitiesApi.md#parsedateusingpost) | **POST** /api/v1/util/datetime | Parse a date


<a name="parsedateusingpost"></a>
# **ParseDateUsingPOST**
> BaseResponseOfstring ParseDateUsingPOST (DatetimeDto datetimeDto)

Parse a date

Provides a simple endpoint to check whether a given date candidate parses with the provided format string.  Both the date candidate and format strings are required. Returns a 200 if the date parses, or a 400 with a message if not. If the date parses, the provided format can be provided as column metadata, and the imported values parse correctly. The format string is java DateTimeFormatter style e.g. dateFormat = \"MM/dd/yyyy\" and candidate = \"07/28/1987\"

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ParseDateUsingPOSTExample
    {
        public void main()
        {
            
            // Configure OAuth2 access token for authorization: oauth
            Configuration.Default.AccessToken = "YOUR_ACCESS_TOKEN";

            var apiInstance = new UtilitiesApi();
            var datetimeDto = new DatetimeDto(); // DatetimeDto | The representation of the datetime object to parse

            try
            {
                // Parse a date
                BaseResponseOfstring result = apiInstance.ParseDateUsingPOST(datetimeDto);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UtilitiesApi.ParseDateUsingPOST: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **datetimeDto** | [**DatetimeDto**](DatetimeDto.md)| The representation of the datetime object to parse | 

### Return type

[**BaseResponseOfstring**](BaseResponseOfstring.md)

### Authorization

[oauth](../README.md#oauth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

