/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using NUnit.Framework;

using IO.Swagger.Client;
using IO.Swagger.Api;
using IO.Swagger.Model;

namespace IO.Swagger.Test
{
    /// <summary>
    ///  Class for testing FileManagementApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by Swagger Codegen.
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    [TestFixture]
    public class FileManagementApiTests
    {
        private FileManagementApi instance;

        /// <summary>
        /// Setup before each unit test
        /// </summary>
        [SetUp]
        public void Init()
        {
            instance = new FileManagementApi();
        }

        /// <summary>
        /// Clean up after each unit test
        /// </summary>
        [TearDown]
        public void Cleanup()
        {

        }

        /// <summary>
        /// Test an instance of FileManagementApi
        /// </summary>
        [Test]
        public void InstanceTest()
        {
            // TODO uncomment below to test 'IsInstanceOfType' FileManagementApi
            //Assert.IsInstanceOfType(typeof(FileManagementApi), instance, "instance is a FileManagementApi");
        }

        
        /// <summary>
        /// Test DeleteFileUsingDELETE
        /// </summary>
        [Test]
        public void DeleteFileUsingDELETETest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string fileId = null;
            //var response = instance.DeleteFileUsingDELETE(fileId);
            //Assert.IsInstanceOf<BaseResponseOfstring> (response, "response is BaseResponseOfstring");
        }
        
        /// <summary>
        /// Test DownloadFileUsingGET
        /// </summary>
        [Test]
        public void DownloadFileUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string fileId = null;
            //var response = instance.DownloadFileUsingGET(fileId);
            //Assert.IsInstanceOf<byte[]> (response, "response is byte[]");
        }
        
        /// <summary>
        /// Test ExportFileToSpreadsheetsUsingPOST
        /// </summary>
        [Test]
        public void ExportFileToSpreadsheetsUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string fileId = null;
            //ExportFileDto exportFileDto = null;
            //var response = instance.ExportFileToSpreadsheetsUsingPOST(fileId, exportFileDto);
            //Assert.IsInstanceOf<BaseResponseOfSpreadsheetInfoDto> (response, "response is BaseResponseOfSpreadsheetInfoDto");
        }
        
        /// <summary>
        /// Test GetErrorsUsingGET
        /// </summary>
        [Test]
        public void GetErrorsUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string fileId = null;
            //int? limit = null;
            //string cursor = null;
            //long? offset = null;
            //var response = instance.GetErrorsUsingGET(fileId, limit, cursor, offset);
            //Assert.IsInstanceOf<PagedResponseOfImportErrorDto> (response, "response is PagedResponseOfImportErrorDto");
        }
        
        /// <summary>
        /// Test GetFileUsingGET
        /// </summary>
        [Test]
        public void GetFileUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string fileId = null;
            //var response = instance.GetFileUsingGET(fileId);
            //Assert.IsInstanceOf<BaseResponseOfFileMetaDto> (response, "response is BaseResponseOfFileMetaDto");
        }
        
        /// <summary>
        /// Test GetFilesUsingGET
        /// </summary>
        [Test]
        public void GetFilesUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //int? limit = null;
            //string cursor = null;
            //long? offset = null;
            //string sortOrder = null;
            //string sortBy = null;
            //string searchText = null;
            //var response = instance.GetFilesUsingGET(tableId, limit, cursor, offset, sortOrder, sortBy, searchText);
            //Assert.IsInstanceOf<PagedResponseOfFileMetaDto> (response, "response is PagedResponseOfFileMetaDto");
        }
        
        /// <summary>
        /// Test UploadFileUsingPOST
        /// </summary>
        [Test]
        public void UploadFileUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //System.IO.Stream file = null;
            //string name = null;
            //string url = null;
            //string source = null;
            //string delimiter = null;
            //var response = instance.UploadFileUsingPOST(tableId, file, name, url, source, delimiter);
            //Assert.IsInstanceOf<BaseResponseOfFileMetaDto> (response, "response is BaseResponseOfFileMetaDto");
        }
        
        /// <summary>
        /// Test ValidateFilenameUsingGET
        /// </summary>
        [Test]
        public void ValidateFilenameUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //string filename = null;
            //var response = instance.ValidateFilenameUsingGET(tableId, filename);
            //Assert.IsInstanceOf<BaseResponseOfstring> (response, "response is BaseResponseOfstring");
        }
        
    }

}
