/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using NUnit.Framework;

using IO.Swagger.Client;
using IO.Swagger.Api;
using IO.Swagger.Model;

namespace IO.Swagger.Test
{
    /// <summary>
    ///  Class for testing QueryManagementApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by Swagger Codegen.
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    [TestFixture]
    public class QueryManagementApiTests
    {
        private QueryManagementApi instance;

        /// <summary>
        /// Setup before each unit test
        /// </summary>
        [SetUp]
        public void Init()
        {
            instance = new QueryManagementApi();
        }

        /// <summary>
        /// Clean up after each unit test
        /// </summary>
        [TearDown]
        public void Cleanup()
        {

        }

        /// <summary>
        /// Test an instance of QueryManagementApi
        /// </summary>
        [Test]
        public void InstanceTest()
        {
            // TODO uncomment below to test 'IsInstanceOfType' QueryManagementApi
            //Assert.IsInstanceOfType(typeof(QueryManagementApi), instance, "instance is a QueryManagementApi");
        }

        
        /// <summary>
        /// Test CancelQueryUsingDELETE
        /// </summary>
        [Test]
        public void CancelQueryUsingDELETETest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryResultId = null;
            //var response = instance.CancelQueryUsingDELETE(queryResultId);
            //Assert.IsInstanceOf<BaseResponseOfQueryResultDto> (response, "response is BaseResponseOfQueryResultDto");
        }
        
        /// <summary>
        /// Test CreateQueryUsingPOST
        /// </summary>
        [Test]
        public void CreateQueryUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //QueryDto queryDto = null;
            //var response = instance.CreateQueryUsingPOST(queryDto);
            //Assert.IsInstanceOf<BaseResponseOfQueryDto> (response, "response is BaseResponseOfQueryDto");
        }
        
        /// <summary>
        /// Test DeleteQueryUsingDELETE
        /// </summary>
        [Test]
        public void DeleteQueryUsingDELETETest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryId = null;
            //var response = instance.DeleteQueryUsingDELETE(queryId);
            //Assert.IsInstanceOf<BaseResponseOfstring> (response, "response is BaseResponseOfstring");
        }
        
        /// <summary>
        /// Test DownloadQueryResultUsingGET
        /// </summary>
        [Test]
        public void DownloadQueryResultUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryResultId = null;
            //var response = instance.DownloadQueryResultUsingGET(queryResultId);
            //Assert.IsInstanceOf<byte[]> (response, "response is byte[]");
        }
        
        /// <summary>
        /// Test ExportQueryResultToSpreadsheetsUsingPOST
        /// </summary>
        [Test]
        public void ExportQueryResultToSpreadsheetsUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryResultId = null;
            //ExportQueryResultDto dto = null;
            //var response = instance.ExportQueryResultToSpreadsheetsUsingPOST(queryResultId, dto);
            //Assert.IsInstanceOf<BaseResponseOfstring> (response, "response is BaseResponseOfstring");
        }
        
        /// <summary>
        /// Test GetDependenciesUsingGET
        /// </summary>
        [Test]
        public void GetDependenciesUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryId = null;
            //int? limit = null;
            //string cursor = null;
            //long? offset = null;
            //var response = instance.GetDependenciesUsingGET(queryId, limit, cursor, offset);
            //Assert.IsInstanceOf<PagedResponseOfTableDto> (response, "response is PagedResponseOfTableDto");
        }
        
        /// <summary>
        /// Test GetQueryColumnDataUsingPOST
        /// </summary>
        [Test]
        public void GetQueryColumnDataUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //QueryTextDto queryTextDto = null;
            //var response = instance.GetQueryColumnDataUsingPOST(queryTextDto);
            //Assert.IsInstanceOf<BaseResponseOfQueryColumnDataDto> (response, "response is BaseResponseOfQueryColumnDataDto");
        }
        
        /// <summary>
        /// Test GetQueryResultUsingGET
        /// </summary>
        [Test]
        public void GetQueryResultUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryResultId = null;
            //var response = instance.GetQueryResultUsingGET(queryResultId);
            //Assert.IsInstanceOf<BaseResponseOfQueryResultDto> (response, "response is BaseResponseOfQueryResultDto");
        }
        
        /// <summary>
        /// Test GetQueryUsingGET
        /// </summary>
        [Test]
        public void GetQueryUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryId = null;
            //var response = instance.GetQueryUsingGET(queryId);
            //Assert.IsInstanceOf<BaseResponseOfQueryDto> (response, "response is BaseResponseOfQueryDto");
        }
        
        /// <summary>
        /// Test GetTablesDependentOnQueryUsingGET
        /// </summary>
        [Test]
        public void GetTablesDependentOnQueryUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryId = null;
            //int? limit = null;
            //string cursor = null;
            //long? offset = null;
            //var response = instance.GetTablesDependentOnQueryUsingGET(queryId, limit, cursor, offset);
            //Assert.IsInstanceOf<PagedResponseOfTableDto> (response, "response is PagedResponseOfTableDto");
        }
        
        /// <summary>
        /// Test IsQueryValidUsingPOST
        /// </summary>
        [Test]
        public void IsQueryValidUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //QueryDto queryDto = null;
            //var response = instance.IsQueryValidUsingPOST(queryDto);
            //Assert.IsInstanceOf<BaseResponseOfQueryDto> (response, "response is BaseResponseOfQueryDto");
        }
        
        /// <summary>
        /// Test ListQueriesUsingGET
        /// </summary>
        [Test]
        public void ListQueriesUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //int? limit = null;
            //string cursor = null;
            //long? offset = null;
            //List<string> ids = null;
            //var response = instance.ListQueriesUsingGET(limit, cursor, offset, ids);
            //Assert.IsInstanceOf<PagedResponseOfQueryDto> (response, "response is PagedResponseOfQueryDto");
        }
        
        /// <summary>
        /// Test ListQueryResultsUsingGET
        /// </summary>
        [Test]
        public void ListQueryResultsUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryId = null;
            //string cursor = null;
            //int? limit = null;
            //long? offset = null;
            //var response = instance.ListQueryResultsUsingGET(queryId, cursor, limit, offset);
            //Assert.IsInstanceOf<PagedResponseOfQueryResultDto> (response, "response is PagedResponseOfQueryResultDto");
        }
        
        /// <summary>
        /// Test PreviewQueryUsingPOST
        /// </summary>
        [Test]
        public void PreviewQueryUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //int? limit = null;
            //string fileName = null;
            //var response = instance.PreviewQueryUsingPOST(tableId, limit, fileName);
            //Assert.IsInstanceOf<BaseResponseOfQueryDto> (response, "response is BaseResponseOfQueryDto");
        }
        
        /// <summary>
        /// Test RunQueryUsingPOST
        /// </summary>
        [Test]
        public void RunQueryUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //QueryResultDto queryResultDto = null;
            //var response = instance.RunQueryUsingPOST(queryResultDto);
            //Assert.IsInstanceOf<BaseResponseOfQueryResultDto> (response, "response is BaseResponseOfQueryResultDto");
        }
        
        /// <summary>
        /// Test UpdateQueryUsingPUT
        /// </summary>
        [Test]
        public void UpdateQueryUsingPUTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string queryId = null;
            //QueryDto queryDto = null;
            //var response = instance.UpdateQueryUsingPUT(queryId, queryDto);
            //Assert.IsInstanceOf<BaseResponseOfQueryDto> (response, "response is BaseResponseOfQueryDto");
        }
        
    }

}
