/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using NUnit.Framework;

using IO.Swagger.Client;
using IO.Swagger.Api;
using IO.Swagger.Model;

namespace IO.Swagger.Test
{
    /// <summary>
    ///  Class for testing TableManagementApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by Swagger Codegen.
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    [TestFixture]
    public class TableManagementApiTests
    {
        private TableManagementApi instance;

        /// <summary>
        /// Setup before each unit test
        /// </summary>
        [SetUp]
        public void Init()
        {
            instance = new TableManagementApi();
        }

        /// <summary>
        /// Clean up after each unit test
        /// </summary>
        [TearDown]
        public void Cleanup()
        {

        }

        /// <summary>
        /// Test an instance of TableManagementApi
        /// </summary>
        [Test]
        public void InstanceTest()
        {
            // TODO uncomment below to test 'IsInstanceOfType' TableManagementApi
            //Assert.IsInstanceOfType(typeof(TableManagementApi), instance, "instance is a TableManagementApi");
        }

        
        /// <summary>
        /// Test CreateTableUsingPOST
        /// </summary>
        [Test]
        public void CreateTableUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //TableDto body = null;
            //var response = instance.CreateTableUsingPOST(body);
            //Assert.IsInstanceOf<BaseResponseOfTableDto> (response, "response is BaseResponseOfTableDto");
        }
        
        /// <summary>
        /// Test DeleteTableUsingDELETE
        /// </summary>
        [Test]
        public void DeleteTableUsingDELETETest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //var response = instance.DeleteTableUsingDELETE(tableId);
            //Assert.IsInstanceOf<BaseResponseOfstring> (response, "response is BaseResponseOfstring");
        }
        
        /// <summary>
        /// Test GetDependentsUsingGET
        /// </summary>
        [Test]
        public void GetDependentsUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //int? limit = null;
            //string cursor = null;
            //long? offset = null;
            //var response = instance.GetDependentsUsingGET(tableId, limit, cursor, offset);
            //Assert.IsInstanceOf<PagedResponseOfQueryDto> (response, "response is PagedResponseOfQueryDto");
        }
        
        /// <summary>
        /// Test GetImportInfoUsingGET
        /// </summary>
        [Test]
        public void GetImportInfoUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //var response = instance.GetImportInfoUsingGET(tableId);
            //Assert.IsInstanceOf<BaseResponseOfImportInfoDto> (response, "response is BaseResponseOfImportInfoDto");
        }
        
        /// <summary>
        /// Test GetTableUsingGET
        /// </summary>
        [Test]
        public void GetTableUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //var response = instance.GetTableUsingGET(tableId);
            //Assert.IsInstanceOf<BaseResponseOfTableDto> (response, "response is BaseResponseOfTableDto");
        }
        
        /// <summary>
        /// Test GetTablesUsingGET
        /// </summary>
        [Test]
        public void GetTablesUsingGETTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //bool? includeShared = null;
            //int? limit = null;
            //string cursor = null;
            //long? offset = null;
            //var response = instance.GetTablesUsingGET(includeShared, limit, cursor, offset);
            //Assert.IsInstanceOf<PagedResponseOfTableDto> (response, "response is PagedResponseOfTableDto");
        }
        
        /// <summary>
        /// Test ImportFileUsingPOST
        /// </summary>
        [Test]
        public void ImportFileUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //ImportDto importDto = null;
            //var response = instance.ImportFileUsingPOST(tableId, importDto);
            //Assert.IsInstanceOf<BaseResponseOfFileMetaDto> (response, "response is BaseResponseOfFileMetaDto");
        }
        
        /// <summary>
        /// Test ImportFromSpreadsheetsUsingPOST
        /// </summary>
        [Test]
        public void ImportFromSpreadsheetsUsingPOSTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //ImportFromSpreadsheetDto importFromSpreadsheetDto = null;
            //var response = instance.ImportFromSpreadsheetsUsingPOST(tableId, importFromSpreadsheetDto);
            //Assert.IsInstanceOf<BaseResponseOfFileMetaDto> (response, "response is BaseResponseOfFileMetaDto");
        }
        
        /// <summary>
        /// Test UnimportFileUsingDELETE
        /// </summary>
        [Test]
        public void UnimportFileUsingDELETETest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string tableId = null;
            //string fileId = null;
            //string force = null;
            //var response = instance.UnimportFileUsingDELETE(tableId, fileId, force);
            //Assert.IsInstanceOf<BaseResponseOfFileMetaDto> (response, "response is BaseResponseOfFileMetaDto");
        }
        
        /// <summary>
        /// Test UpdateTableUsingPUT
        /// </summary>
        [Test]
        public void UpdateTableUsingPUTTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //TableDto tableDto = null;
            //string tableId = null;
            //var response = instance.UpdateTableUsingPUT(tableDto, tableId);
            //Assert.IsInstanceOf<BaseResponseOfTableDto> (response, "response is BaseResponseOfTableDto");
        }
        
    }

}
