/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ConnectionDto
    /// </summary>
    [DataContract]
    public partial class ConnectionDto :  IEquatable<ConnectionDto>
    {
        /// <summary>
        /// The type of file or item the connection sends data to
        /// </summary>
        /// <value>The type of file or item the connection sends data to</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum DestinationTypeEnum
        {
            
            /// <summary>
            /// Enum Spreadsheet for "spreadsheet"
            /// </summary>
            [EnumMember(Value = "spreadsheet")]
            Spreadsheet,
            
            /// <summary>
            /// Enum Spreadsheetsection for "spreadsheet_section"
            /// </summary>
            [EnumMember(Value = "spreadsheet_section")]
            Spreadsheetsection,
            
            /// <summary>
            /// Enum Presentation for "presentation"
            /// </summary>
            [EnumMember(Value = "presentation")]
            Presentation,
            
            /// <summary>
            /// Enum Presentationchart for "presentation_chart"
            /// </summary>
            [EnumMember(Value = "presentation_chart")]
            Presentationchart,
            
            /// <summary>
            /// Enum Presentationembeddedtable for "presentation_embedded_table"
            /// </summary>
            [EnumMember(Value = "presentation_embedded_table")]
            Presentationembeddedtable,
            
            /// <summary>
            /// Enum Document for "document"
            /// </summary>
            [EnumMember(Value = "document")]
            Document,
            
            /// <summary>
            /// Enum Documentchart for "document_chart"
            /// </summary>
            [EnumMember(Value = "document_chart")]
            Documentchart,
            
            /// <summary>
            /// Enum Documentembeddedtable for "document_embedded_table"
            /// </summary>
            [EnumMember(Value = "document_embedded_table")]
            Documentembeddedtable,
            
            /// <summary>
            /// Enum Wdataquery for "wdata_query"
            /// </summary>
            [EnumMember(Value = "wdata_query")]
            Wdataquery,
            
            /// <summary>
            /// Enum Wdatatable for "wdata_table"
            /// </summary>
            [EnumMember(Value = "wdata_table")]
            Wdatatable,
            
            /// <summary>
            /// Enum Wdatatabledataset for "wdata_table_dataset"
            /// </summary>
            [EnumMember(Value = "wdata_table_dataset")]
            Wdatatabledataset,
            
            /// <summary>
            /// Enum Report for "report"
            /// </summary>
            [EnumMember(Value = "report")]
            Report,
            
            /// <summary>
            /// Enum Unknownrecordtype for "unknown_record_type"
            /// </summary>
            [EnumMember(Value = "unknown_record_type")]
            Unknownrecordtype
        }

        /// <summary>
        /// The type of file or item the connection pulls data from
        /// </summary>
        /// <value>The type of file or item the connection pulls data from</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SourceTypeEnum
        {
            
            /// <summary>
            /// Enum Spreadsheet for "spreadsheet"
            /// </summary>
            [EnumMember(Value = "spreadsheet")]
            Spreadsheet,
            
            /// <summary>
            /// Enum Spreadsheetsection for "spreadsheet_section"
            /// </summary>
            [EnumMember(Value = "spreadsheet_section")]
            Spreadsheetsection,
            
            /// <summary>
            /// Enum Presentation for "presentation"
            /// </summary>
            [EnumMember(Value = "presentation")]
            Presentation,
            
            /// <summary>
            /// Enum Presentationchart for "presentation_chart"
            /// </summary>
            [EnumMember(Value = "presentation_chart")]
            Presentationchart,
            
            /// <summary>
            /// Enum Presentationembeddedtable for "presentation_embedded_table"
            /// </summary>
            [EnumMember(Value = "presentation_embedded_table")]
            Presentationembeddedtable,
            
            /// <summary>
            /// Enum Document for "document"
            /// </summary>
            [EnumMember(Value = "document")]
            Document,
            
            /// <summary>
            /// Enum Documentchart for "document_chart"
            /// </summary>
            [EnumMember(Value = "document_chart")]
            Documentchart,
            
            /// <summary>
            /// Enum Documentembeddedtable for "document_embedded_table"
            /// </summary>
            [EnumMember(Value = "document_embedded_table")]
            Documentembeddedtable,
            
            /// <summary>
            /// Enum Wdataquery for "wdata_query"
            /// </summary>
            [EnumMember(Value = "wdata_query")]
            Wdataquery,
            
            /// <summary>
            /// Enum Wdatatable for "wdata_table"
            /// </summary>
            [EnumMember(Value = "wdata_table")]
            Wdatatable,
            
            /// <summary>
            /// Enum Wdatatabledataset for "wdata_table_dataset"
            /// </summary>
            [EnumMember(Value = "wdata_table_dataset")]
            Wdatatabledataset,
            
            /// <summary>
            /// Enum Report for "report"
            /// </summary>
            [EnumMember(Value = "report")]
            Report,
            
            /// <summary>
            /// Enum Unknownrecordtype for "unknown_record_type"
            /// </summary>
            [EnumMember(Value = "unknown_record_type")]
            Unknownrecordtype
        }

        /// <summary>
        /// The type of file or item the connection sends data to
        /// </summary>
        /// <value>The type of file or item the connection sends data to</value>
        [DataMember(Name="destinationType", EmitDefaultValue=false)]
        public DestinationTypeEnum? DestinationType { get; set; }
        /// <summary>
        /// The type of file or item the connection pulls data from
        /// </summary>
        /// <value>The type of file or item the connection pulls data from</value>
        [DataMember(Name="sourceType", EmitDefaultValue=false)]
        public SourceTypeEnum? SourceType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ConnectionDto" /> class.
        /// </summary>
        /// <param name="LastRunDestinationParameters">A map of the parameters used with the destination when the connection last ran.</param>
        /// <param name="LastRunSourceParameters">A map of the parameters used with the source when the connection last ran.</param>
        /// <param name="Metadata">Any additional information about the connection.</param>
        public ConnectionDto(Dictionary<string, Object> LastRunDestinationParameters = null, Dictionary<string, Object> LastRunSourceParameters = null, Dictionary<string, Object> Metadata = null)
        {
            this.LastRunDestinationParameters = LastRunDestinationParameters;
            this.LastRunSourceParameters = LastRunSourceParameters;
            this.Metadata = Metadata;
        }
        
        /// <summary>
        /// The unique ID of the connection
        /// </summary>
        /// <value>The unique ID of the connection</value>
        [DataMember(Name="connectionId", EmitDefaultValue=false)]
        public string ConnectionId { get; private set; }
        /// <summary>
        /// When the connection was created, as a datetime
        /// </summary>
        /// <value>When the connection was created, as a datetime</value>
        [DataMember(Name="created", EmitDefaultValue=false)]
        public DateTime? Created { get; private set; }
        /// <summary>
        /// The ID of the user that created the connection
        /// </summary>
        /// <value>The ID of the user that created the connection</value>
        [DataMember(Name="createdBy", EmitDefaultValue=false)]
        public string CreatedBy { get; private set; }
        /// <summary>
        /// The description of the connection, if specified
        /// </summary>
        /// <value>The description of the connection, if specified</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; private set; }
        /// <summary>
        /// The ID of the file or item the connection sends data to
        /// </summary>
        /// <value>The ID of the file or item the connection sends data to</value>
        [DataMember(Name="destinationId", EmitDefaultValue=false)]
        public string DestinationId { get; private set; }
        /// <summary>
        /// The workspace of the file or item the connection pulls data to
        /// </summary>
        /// <value>The workspace of the file or item the connection pulls data to</value>
        [DataMember(Name="destinationWorkspaceId", EmitDefaultValue=false)]
        public string DestinationWorkspaceId { get; private set; }
        /// <summary>
        /// The ID of the user that last ran the connection
        /// </summary>
        /// <value>The ID of the user that last ran the connection</value>
        [DataMember(Name="lastRunBy", EmitDefaultValue=false)]
        public string LastRunBy { get; private set; }
        /// <summary>
        /// When the connection last ran, as a datetime
        /// </summary>
        /// <value>When the connection last ran, as a datetime</value>
        [DataMember(Name="lastRunDate", EmitDefaultValue=false)]
        public DateTime? LastRunDate { get; private set; }
        /// <summary>
        /// A map of the parameters used with the destination when the connection last ran
        /// </summary>
        /// <value>A map of the parameters used with the destination when the connection last ran</value>
        [DataMember(Name="lastRunDestinationParameters", EmitDefaultValue=false)]
        public Dictionary<string, Object> LastRunDestinationParameters { get; set; }
        /// <summary>
        /// The ID of the connection&#39;s last run
        /// </summary>
        /// <value>The ID of the connection&#39;s last run</value>
        [DataMember(Name="lastRunJobId", EmitDefaultValue=false)]
        public string LastRunJobId { get; private set; }
        /// <summary>
        /// A map of the parameters used with the source when the connection last ran
        /// </summary>
        /// <value>A map of the parameters used with the source when the connection last ran</value>
        [DataMember(Name="lastRunSourceParameters", EmitDefaultValue=false)]
        public Dictionary<string, Object> LastRunSourceParameters { get; set; }
        /// <summary>
        /// Any additional information about the connection
        /// </summary>
        /// <value>Any additional information about the connection</value>
        [DataMember(Name="metadata", EmitDefaultValue=false)]
        public Dictionary<string, Object> Metadata { get; set; }
        /// <summary>
        /// The name of the connection, if specified
        /// </summary>
        /// <value>The name of the connection, if specified</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; private set; }
        /// <summary>
        /// The ID of the file or item the connection pulls data from
        /// </summary>
        /// <value>The ID of the file or item the connection pulls data from</value>
        [DataMember(Name="sourceId", EmitDefaultValue=false)]
        public string SourceId { get; private set; }
        /// <summary>
        /// The workspace of the file or item the connection pulls data from
        /// </summary>
        /// <value>The workspace of the file or item the connection pulls data from</value>
        [DataMember(Name="sourceWorkspaceId", EmitDefaultValue=false)]
        public string SourceWorkspaceId { get; private set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ConnectionDto {\n");
            sb.Append("  ConnectionId: ").Append(ConnectionId).Append("\n");
            sb.Append("  Created: ").Append(Created).Append("\n");
            sb.Append("  CreatedBy: ").Append(CreatedBy).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  DestinationId: ").Append(DestinationId).Append("\n");
            sb.Append("  DestinationType: ").Append(DestinationType).Append("\n");
            sb.Append("  DestinationWorkspaceId: ").Append(DestinationWorkspaceId).Append("\n");
            sb.Append("  LastRunBy: ").Append(LastRunBy).Append("\n");
            sb.Append("  LastRunDate: ").Append(LastRunDate).Append("\n");
            sb.Append("  LastRunDestinationParameters: ").Append(LastRunDestinationParameters).Append("\n");
            sb.Append("  LastRunJobId: ").Append(LastRunJobId).Append("\n");
            sb.Append("  LastRunSourceParameters: ").Append(LastRunSourceParameters).Append("\n");
            sb.Append("  Metadata: ").Append(Metadata).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  SourceId: ").Append(SourceId).Append("\n");
            sb.Append("  SourceType: ").Append(SourceType).Append("\n");
            sb.Append("  SourceWorkspaceId: ").Append(SourceWorkspaceId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as ConnectionDto);
        }

        /// <summary>
        /// Returns true if ConnectionDto instances are equal
        /// </summary>
        /// <param name="other">Instance of ConnectionDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ConnectionDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.ConnectionId == other.ConnectionId ||
                    this.ConnectionId != null &&
                    this.ConnectionId.Equals(other.ConnectionId)
                ) && 
                (
                    this.Created == other.Created ||
                    this.Created != null &&
                    this.Created.Equals(other.Created)
                ) && 
                (
                    this.CreatedBy == other.CreatedBy ||
                    this.CreatedBy != null &&
                    this.CreatedBy.Equals(other.CreatedBy)
                ) && 
                (
                    this.Description == other.Description ||
                    this.Description != null &&
                    this.Description.Equals(other.Description)
                ) && 
                (
                    this.DestinationId == other.DestinationId ||
                    this.DestinationId != null &&
                    this.DestinationId.Equals(other.DestinationId)
                ) && 
                (
                    this.DestinationType == other.DestinationType ||
                    this.DestinationType != null &&
                    this.DestinationType.Equals(other.DestinationType)
                ) && 
                (
                    this.DestinationWorkspaceId == other.DestinationWorkspaceId ||
                    this.DestinationWorkspaceId != null &&
                    this.DestinationWorkspaceId.Equals(other.DestinationWorkspaceId)
                ) && 
                (
                    this.LastRunBy == other.LastRunBy ||
                    this.LastRunBy != null &&
                    this.LastRunBy.Equals(other.LastRunBy)
                ) && 
                (
                    this.LastRunDate == other.LastRunDate ||
                    this.LastRunDate != null &&
                    this.LastRunDate.Equals(other.LastRunDate)
                ) && 
                (
                    this.LastRunDestinationParameters == other.LastRunDestinationParameters ||
                    this.LastRunDestinationParameters != null &&
                    this.LastRunDestinationParameters.SequenceEqual(other.LastRunDestinationParameters)
                ) && 
                (
                    this.LastRunJobId == other.LastRunJobId ||
                    this.LastRunJobId != null &&
                    this.LastRunJobId.Equals(other.LastRunJobId)
                ) && 
                (
                    this.LastRunSourceParameters == other.LastRunSourceParameters ||
                    this.LastRunSourceParameters != null &&
                    this.LastRunSourceParameters.SequenceEqual(other.LastRunSourceParameters)
                ) && 
                (
                    this.Metadata == other.Metadata ||
                    this.Metadata != null &&
                    this.Metadata.SequenceEqual(other.Metadata)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                ) && 
                (
                    this.SourceId == other.SourceId ||
                    this.SourceId != null &&
                    this.SourceId.Equals(other.SourceId)
                ) && 
                (
                    this.SourceType == other.SourceType ||
                    this.SourceType != null &&
                    this.SourceType.Equals(other.SourceType)
                ) && 
                (
                    this.SourceWorkspaceId == other.SourceWorkspaceId ||
                    this.SourceWorkspaceId != null &&
                    this.SourceWorkspaceId.Equals(other.SourceWorkspaceId)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.ConnectionId != null)
                    hash = hash * 59 + this.ConnectionId.GetHashCode();
                if (this.Created != null)
                    hash = hash * 59 + this.Created.GetHashCode();
                if (this.CreatedBy != null)
                    hash = hash * 59 + this.CreatedBy.GetHashCode();
                if (this.Description != null)
                    hash = hash * 59 + this.Description.GetHashCode();
                if (this.DestinationId != null)
                    hash = hash * 59 + this.DestinationId.GetHashCode();
                if (this.DestinationType != null)
                    hash = hash * 59 + this.DestinationType.GetHashCode();
                if (this.DestinationWorkspaceId != null)
                    hash = hash * 59 + this.DestinationWorkspaceId.GetHashCode();
                if (this.LastRunBy != null)
                    hash = hash * 59 + this.LastRunBy.GetHashCode();
                if (this.LastRunDate != null)
                    hash = hash * 59 + this.LastRunDate.GetHashCode();
                if (this.LastRunDestinationParameters != null)
                    hash = hash * 59 + this.LastRunDestinationParameters.GetHashCode();
                if (this.LastRunJobId != null)
                    hash = hash * 59 + this.LastRunJobId.GetHashCode();
                if (this.LastRunSourceParameters != null)
                    hash = hash * 59 + this.LastRunSourceParameters.GetHashCode();
                if (this.Metadata != null)
                    hash = hash * 59 + this.Metadata.GetHashCode();
                if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                if (this.SourceId != null)
                    hash = hash * 59 + this.SourceId.GetHashCode();
                if (this.SourceType != null)
                    hash = hash * 59 + this.SourceType.GetHashCode();
                if (this.SourceWorkspaceId != null)
                    hash = hash * 59 + this.SourceWorkspaceId.GetHashCode();
                return hash;
            }
        }
    }

}
