/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DatetimeDto
    /// </summary>
    [DataContract]
    public partial class DatetimeDto :  IEquatable<DatetimeDto>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DatetimeDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DatetimeDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DatetimeDto" /> class.
        /// </summary>
        /// <param name="Candidate">Candidate to parse with the provided dateformat. (required).</param>
        /// <param name="DateFormat">The dateformat of the candidate to test. (required).</param>
        public DatetimeDto(string Candidate = null, string DateFormat = null)
        {
            // to ensure "Candidate" is required (not null)
            if (Candidate == null)
            {
                throw new InvalidDataException("Candidate is a required property for DatetimeDto and cannot be null");
            }
            else
            {
                this.Candidate = Candidate;
            }
            // to ensure "DateFormat" is required (not null)
            if (DateFormat == null)
            {
                throw new InvalidDataException("DateFormat is a required property for DatetimeDto and cannot be null");
            }
            else
            {
                this.DateFormat = DateFormat;
            }
        }
        
        /// <summary>
        /// Candidate to parse with the provided dateformat.
        /// </summary>
        /// <value>Candidate to parse with the provided dateformat.</value>
        [DataMember(Name="candidate", EmitDefaultValue=false)]
        public string Candidate { get; set; }
        /// <summary>
        /// The dateformat of the candidate to test.
        /// </summary>
        /// <value>The dateformat of the candidate to test.</value>
        [DataMember(Name="dateFormat", EmitDefaultValue=false)]
        public string DateFormat { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DatetimeDto {\n");
            sb.Append("  Candidate: ").Append(Candidate).Append("\n");
            sb.Append("  DateFormat: ").Append(DateFormat).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as DatetimeDto);
        }

        /// <summary>
        /// Returns true if DatetimeDto instances are equal
        /// </summary>
        /// <param name="other">Instance of DatetimeDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DatetimeDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Candidate == other.Candidate ||
                    this.Candidate != null &&
                    this.Candidate.Equals(other.Candidate)
                ) && 
                (
                    this.DateFormat == other.DateFormat ||
                    this.DateFormat != null &&
                    this.DateFormat.Equals(other.DateFormat)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Candidate != null)
                    hash = hash * 59 + this.Candidate.GetHashCode();
                if (this.DateFormat != null)
                    hash = hash * 59 + this.DateFormat.GetHashCode();
                return hash;
            }
        }
    }

}
