/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ExportQueryResultDto
    /// </summary>
    [DataContract]
    public partial class ExportQueryResultDto :  IEquatable<ExportQueryResultDto>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ExportQueryResultDto" /> class.
        /// </summary>
        /// <param name="ExportAsDataset">If set to true, the data will be exported as a connected dataset to spreadsheets..</param>
        /// <param name="Url">URL of the spreadsheet to export to, if present. If not present, a new spreadsheet will be created..</param>
        /// <param name="UseFlatKey">Export flat query results in the context of crosstab queries; Ignored unless true..</param>
        public ExportQueryResultDto(bool? ExportAsDataset = null, string Url = null, bool? UseFlatKey = null)
        {
            this.ExportAsDataset = ExportAsDataset;
            this.Url = Url;
            this.UseFlatKey = UseFlatKey;
        }
        
        /// <summary>
        /// If set to true, the data will be exported as a connected dataset to spreadsheets.
        /// </summary>
        /// <value>If set to true, the data will be exported as a connected dataset to spreadsheets.</value>
        [DataMember(Name="exportAsDataset", EmitDefaultValue=false)]
        public bool? ExportAsDataset { get; set; }
        /// <summary>
        /// URL of the spreadsheet to export to, if present. If not present, a new spreadsheet will be created.
        /// </summary>
        /// <value>URL of the spreadsheet to export to, if present. If not present, a new spreadsheet will be created.</value>
        [DataMember(Name="url", EmitDefaultValue=false)]
        public string Url { get; set; }
        /// <summary>
        /// Export flat query results in the context of crosstab queries; Ignored unless true.
        /// </summary>
        /// <value>Export flat query results in the context of crosstab queries; Ignored unless true.</value>
        [DataMember(Name="useFlatKey", EmitDefaultValue=false)]
        public bool? UseFlatKey { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ExportQueryResultDto {\n");
            sb.Append("  ExportAsDataset: ").Append(ExportAsDataset).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  UseFlatKey: ").Append(UseFlatKey).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as ExportQueryResultDto);
        }

        /// <summary>
        /// Returns true if ExportQueryResultDto instances are equal
        /// </summary>
        /// <param name="other">Instance of ExportQueryResultDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ExportQueryResultDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.ExportAsDataset == other.ExportAsDataset ||
                    this.ExportAsDataset != null &&
                    this.ExportAsDataset.Equals(other.ExportAsDataset)
                ) && 
                (
                    this.Url == other.Url ||
                    this.Url != null &&
                    this.Url.Equals(other.Url)
                ) && 
                (
                    this.UseFlatKey == other.UseFlatKey ||
                    this.UseFlatKey != null &&
                    this.UseFlatKey.Equals(other.UseFlatKey)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.ExportAsDataset != null)
                    hash = hash * 59 + this.ExportAsDataset.GetHashCode();
                if (this.Url != null)
                    hash = hash * 59 + this.Url.GetHashCode();
                if (this.UseFlatKey != null)
                    hash = hash * 59 + this.UseFlatKey.GetHashCode();
                return hash;
            }
        }
    }

}
