/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ImportInfoDto
    /// </summary>
    [DataContract]
    public partial class ImportInfoDto :  IEquatable<ImportInfoDto>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImportInfoDto" /> class.
        /// </summary>
        /// <param name="NumFiles">The total number of individual files imported to the table..</param>
        /// <param name="NumRecords">The total number of records/rows of data imported to the table..</param>
        /// <param name="TableId">The id for the table that the import info applies to..</param>
        public ImportInfoDto(long? NumFiles = null, long? NumRecords = null, string TableId = null)
        {
            this.NumFiles = NumFiles;
            this.NumRecords = NumRecords;
            this.TableId = TableId;
        }
        
        /// <summary>
        /// The total number of individual files imported to the table.
        /// </summary>
        /// <value>The total number of individual files imported to the table.</value>
        [DataMember(Name="numFiles", EmitDefaultValue=false)]
        public long? NumFiles { get; set; }
        /// <summary>
        /// The total number of records/rows of data imported to the table.
        /// </summary>
        /// <value>The total number of records/rows of data imported to the table.</value>
        [DataMember(Name="numRecords", EmitDefaultValue=false)]
        public long? NumRecords { get; set; }
        /// <summary>
        /// The id for the table that the import info applies to.
        /// </summary>
        /// <value>The id for the table that the import info applies to.</value>
        [DataMember(Name="tableId", EmitDefaultValue=false)]
        public string TableId { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ImportInfoDto {\n");
            sb.Append("  NumFiles: ").Append(NumFiles).Append("\n");
            sb.Append("  NumRecords: ").Append(NumRecords).Append("\n");
            sb.Append("  TableId: ").Append(TableId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as ImportInfoDto);
        }

        /// <summary>
        /// Returns true if ImportInfoDto instances are equal
        /// </summary>
        /// <param name="other">Instance of ImportInfoDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImportInfoDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.NumFiles == other.NumFiles ||
                    this.NumFiles != null &&
                    this.NumFiles.Equals(other.NumFiles)
                ) && 
                (
                    this.NumRecords == other.NumRecords ||
                    this.NumRecords != null &&
                    this.NumRecords.Equals(other.NumRecords)
                ) && 
                (
                    this.TableId == other.TableId ||
                    this.TableId != null &&
                    this.TableId.Equals(other.TableId)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.NumFiles != null)
                    hash = hash * 59 + this.NumFiles.GetHashCode();
                if (this.NumRecords != null)
                    hash = hash * 59 + this.NumRecords.GetHashCode();
                if (this.TableId != null)
                    hash = hash * 59 + this.TableId.GetHashCode();
                return hash;
            }
        }
    }

}
