/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PivotViewDefinitionFilterDto
    /// </summary>
    [DataContract]
    public partial class PivotViewDefinitionFilterDto :  IEquatable<PivotViewDefinitionFilterDto>
    {
        /// <summary>
        /// The column type.
        /// </summary>
        /// <value>The column type.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ColumnTypeEnum
        {
            
            /// <summary>
            /// Enum Integer for "integer"
            /// </summary>
            [EnumMember(Value = "integer")]
            Integer,
            
            /// <summary>
            /// Enum Number for "number"
            /// </summary>
            [EnumMember(Value = "number")]
            Number,
            
            /// <summary>
            /// Enum Boolean for "boolean"
            /// </summary>
            [EnumMember(Value = "boolean")]
            Boolean,
            
            /// <summary>
            /// Enum Timestamp for "timestamp"
            /// </summary>
            [EnumMember(Value = "timestamp")]
            Timestamp,
            
            /// <summary>
            /// Enum Date for "date"
            /// </summary>
            [EnumMember(Value = "date")]
            Date,
            
            /// <summary>
            /// Enum String for "string"
            /// </summary>
            [EnumMember(Value = "string")]
            String,
            
            /// <summary>
            /// Enum Float for "float"
            /// </summary>
            [EnumMember(Value = "float")]
            Float
        }

        /// <summary>
        /// The filter to perform.
        /// </summary>
        /// <value>The filter to perform.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum FilterEnum
        {
            
            /// <summary>
            /// Enum EQUAL for "EQUAL"
            /// </summary>
            [EnumMember(Value = "EQUAL")]
            EQUAL,
            
            /// <summary>
            /// Enum NOTEQUAL for "NOT_EQUAL"
            /// </summary>
            [EnumMember(Value = "NOT_EQUAL")]
            NOTEQUAL,
            
            /// <summary>
            /// Enum GREATER for "GREATER"
            /// </summary>
            [EnumMember(Value = "GREATER")]
            GREATER,
            
            /// <summary>
            /// Enum GREATEROREQUAL for "GREATER_OR_EQUAL"
            /// </summary>
            [EnumMember(Value = "GREATER_OR_EQUAL")]
            GREATEROREQUAL,
            
            /// <summary>
            /// Enum LESS for "LESS"
            /// </summary>
            [EnumMember(Value = "LESS")]
            LESS,
            
            /// <summary>
            /// Enum LESSOREQUAL for "LESS_OR_EQUAL"
            /// </summary>
            [EnumMember(Value = "LESS_OR_EQUAL")]
            LESSOREQUAL,
            
            /// <summary>
            /// Enum BETWEEN for "BETWEEN"
            /// </summary>
            [EnumMember(Value = "BETWEEN")]
            BETWEEN,
            
            /// <summary>
            /// Enum NOTBETWEEN for "NOT_BETWEEN"
            /// </summary>
            [EnumMember(Value = "NOT_BETWEEN")]
            NOTBETWEEN
        }

        /// <summary>
        /// The column type.
        /// </summary>
        /// <value>The column type.</value>
        [DataMember(Name="columnType", EmitDefaultValue=false)]
        public ColumnTypeEnum? ColumnType { get; set; }
        /// <summary>
        /// The filter to perform.
        /// </summary>
        /// <value>The filter to perform.</value>
        [DataMember(Name="filter", EmitDefaultValue=false)]
        public FilterEnum? Filter { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="PivotViewDefinitionFilterDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PivotViewDefinitionFilterDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PivotViewDefinitionFilterDto" /> class.
        /// </summary>
        /// <param name="BetweenValue">A second value for &#39;between&#39; filters.</param>
        /// <param name="ColumnType">The column type. (required).</param>
        /// <param name="Exclude">True if value list is exclude, false if value list is include. Defaults to true..</param>
        /// <param name="Filter">The filter to perform..</param>
        /// <param name="FilterValues">The values obtained after applying the filter.</param>
        /// <param name="Name">The column for the pivot view filter. The maximum size is 255 characters. (required).</param>
        /// <param name="Value">The value to filter on..</param>
        public PivotViewDefinitionFilterDto(string BetweenValue = null, ColumnTypeEnum? ColumnType = null, bool? Exclude = null, FilterEnum? Filter = null, List<string> FilterValues = null, string Name = null, string Value = null)
        {
            // to ensure "ColumnType" is required (not null)
            if (ColumnType == null)
            {
                throw new InvalidDataException("ColumnType is a required property for PivotViewDefinitionFilterDto and cannot be null");
            }
            else
            {
                this.ColumnType = ColumnType;
            }
            // to ensure "Name" is required (not null)
            if (Name == null)
            {
                throw new InvalidDataException("Name is a required property for PivotViewDefinitionFilterDto and cannot be null");
            }
            else
            {
                this.Name = Name;
            }
            this.BetweenValue = BetweenValue;
            this.Exclude = Exclude;
            this.Filter = Filter;
            this.FilterValues = FilterValues;
            this.Value = Value;
        }
        
        /// <summary>
        /// A second value for &#39;between&#39; filters
        /// </summary>
        /// <value>A second value for &#39;between&#39; filters</value>
        [DataMember(Name="betweenValue", EmitDefaultValue=false)]
        public string BetweenValue { get; set; }
        /// <summary>
        /// True if value list is exclude, false if value list is include. Defaults to true.
        /// </summary>
        /// <value>True if value list is exclude, false if value list is include. Defaults to true.</value>
        [DataMember(Name="exclude", EmitDefaultValue=false)]
        public bool? Exclude { get; set; }
        /// <summary>
        /// The values obtained after applying the filter
        /// </summary>
        /// <value>The values obtained after applying the filter</value>
        [DataMember(Name="filterValues", EmitDefaultValue=false)]
        public List<string> FilterValues { get; set; }
        /// <summary>
        /// The column for the pivot view filter. The maximum size is 255 characters.
        /// </summary>
        /// <value>The column for the pivot view filter. The maximum size is 255 characters.</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }
        /// <summary>
        /// The value to filter on.
        /// </summary>
        /// <value>The value to filter on.</value>
        [DataMember(Name="value", EmitDefaultValue=false)]
        public string Value { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PivotViewDefinitionFilterDto {\n");
            sb.Append("  BetweenValue: ").Append(BetweenValue).Append("\n");
            sb.Append("  ColumnType: ").Append(ColumnType).Append("\n");
            sb.Append("  Exclude: ").Append(Exclude).Append("\n");
            sb.Append("  Filter: ").Append(Filter).Append("\n");
            sb.Append("  FilterValues: ").Append(FilterValues).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Value: ").Append(Value).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as PivotViewDefinitionFilterDto);
        }

        /// <summary>
        /// Returns true if PivotViewDefinitionFilterDto instances are equal
        /// </summary>
        /// <param name="other">Instance of PivotViewDefinitionFilterDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PivotViewDefinitionFilterDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.BetweenValue == other.BetweenValue ||
                    this.BetweenValue != null &&
                    this.BetweenValue.Equals(other.BetweenValue)
                ) && 
                (
                    this.ColumnType == other.ColumnType ||
                    this.ColumnType != null &&
                    this.ColumnType.Equals(other.ColumnType)
                ) && 
                (
                    this.Exclude == other.Exclude ||
                    this.Exclude != null &&
                    this.Exclude.Equals(other.Exclude)
                ) && 
                (
                    this.Filter == other.Filter ||
                    this.Filter != null &&
                    this.Filter.Equals(other.Filter)
                ) && 
                (
                    this.FilterValues == other.FilterValues ||
                    this.FilterValues != null &&
                    this.FilterValues.SequenceEqual(other.FilterValues)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                ) && 
                (
                    this.Value == other.Value ||
                    this.Value != null &&
                    this.Value.Equals(other.Value)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.BetweenValue != null)
                    hash = hash * 59 + this.BetweenValue.GetHashCode();
                if (this.ColumnType != null)
                    hash = hash * 59 + this.ColumnType.GetHashCode();
                if (this.Exclude != null)
                    hash = hash * 59 + this.Exclude.GetHashCode();
                if (this.Filter != null)
                    hash = hash * 59 + this.Filter.GetHashCode();
                if (this.FilterValues != null)
                    hash = hash * 59 + this.FilterValues.GetHashCode();
                if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                if (this.Value != null)
                    hash = hash * 59 + this.Value.GetHashCode();
                return hash;
            }
        }
    }

}
