/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// PivotViewDefinitionValueDto
    /// </summary>
    [DataContract]
    public partial class PivotViewDefinitionValueDto :  IEquatable<PivotViewDefinitionValueDto>
    {
        /// <summary>
        /// The aggregation type to apply to the pivot view value
        /// </summary>
        /// <value>The aggregation type to apply to the pivot view value</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum AggregationEnum
        {
            
            /// <summary>
            /// Enum Sum for "sum"
            /// </summary>
            [EnumMember(Value = "sum")]
            Sum,
            
            /// <summary>
            /// Enum Count for "count"
            /// </summary>
            [EnumMember(Value = "count")]
            Count,
            
            /// <summary>
            /// Enum Distinctcount for "distinctcount"
            /// </summary>
            [EnumMember(Value = "distinctcount")]
            Distinctcount,
            
            /// <summary>
            /// Enum Average for "average"
            /// </summary>
            [EnumMember(Value = "average")]
            Average,
            
            /// <summary>
            /// Enum Median for "median"
            /// </summary>
            [EnumMember(Value = "median")]
            Median,
            
            /// <summary>
            /// Enum Product for "product"
            /// </summary>
            [EnumMember(Value = "product")]
            Product,
            
            /// <summary>
            /// Enum Min for "min"
            /// </summary>
            [EnumMember(Value = "min")]
            Min,
            
            /// <summary>
            /// Enum Max for "max"
            /// </summary>
            [EnumMember(Value = "max")]
            Max,
            
            /// <summary>
            /// Enum Percent for "percent"
            /// </summary>
            [EnumMember(Value = "percent")]
            Percent,
            
            /// <summary>
            /// Enum Percentofcolumn for "percentofcolumn"
            /// </summary>
            [EnumMember(Value = "percentofcolumn")]
            Percentofcolumn,
            
            /// <summary>
            /// Enum Percentofrow for "percentofrow"
            /// </summary>
            [EnumMember(Value = "percentofrow")]
            Percentofrow,
            
            /// <summary>
            /// Enum Difference for "difference"
            /// </summary>
            [EnumMember(Value = "difference")]
            Difference,
            
            /// <summary>
            /// Enum Percentdifference for "percentdifference"
            /// </summary>
            [EnumMember(Value = "percentdifference")]
            Percentdifference,
            
            /// <summary>
            /// Enum Runningtotals for "runningtotals"
            /// </summary>
            [EnumMember(Value = "runningtotals")]
            Runningtotals,
            
            /// <summary>
            /// Enum Stdevp for "stdevp"
            /// </summary>
            [EnumMember(Value = "stdevp")]
            Stdevp,
            
            /// <summary>
            /// Enum Stdevs for "stdevs"
            /// </summary>
            [EnumMember(Value = "stdevs")]
            Stdevs
        }

        /// <summary>
        /// The column type.
        /// </summary>
        /// <value>The column type.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ColumnTypeEnum
        {
            
            /// <summary>
            /// Enum Integer for "integer"
            /// </summary>
            [EnumMember(Value = "integer")]
            Integer,
            
            /// <summary>
            /// Enum Number for "number"
            /// </summary>
            [EnumMember(Value = "number")]
            Number,
            
            /// <summary>
            /// Enum Boolean for "boolean"
            /// </summary>
            [EnumMember(Value = "boolean")]
            Boolean,
            
            /// <summary>
            /// Enum Timestamp for "timestamp"
            /// </summary>
            [EnumMember(Value = "timestamp")]
            Timestamp,
            
            /// <summary>
            /// Enum Date for "date"
            /// </summary>
            [EnumMember(Value = "date")]
            Date,
            
            /// <summary>
            /// Enum String for "string"
            /// </summary>
            [EnumMember(Value = "string")]
            String,
            
            /// <summary>
            /// Enum Float for "float"
            /// </summary>
            [EnumMember(Value = "float")]
            Float
        }

        /// <summary>
        /// The aggregation type to apply to the pivot view value
        /// </summary>
        /// <value>The aggregation type to apply to the pivot view value</value>
        [DataMember(Name="aggregation", EmitDefaultValue=false)]
        public AggregationEnum? Aggregation { get; set; }
        /// <summary>
        /// The column type.
        /// </summary>
        /// <value>The column type.</value>
        [DataMember(Name="columnType", EmitDefaultValue=false)]
        public ColumnTypeEnum? ColumnType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="PivotViewDefinitionValueDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PivotViewDefinitionValueDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PivotViewDefinitionValueDto" /> class.
        /// </summary>
        /// <param name="Active">Active (required).</param>
        /// <param name="Aggregation">The aggregation type to apply to the pivot view value (required).</param>
        /// <param name="ColumnType">The column type..</param>
        /// <param name="Name">Name of the pivot view value. The maximum size is 255 characters. (required).</param>
        public PivotViewDefinitionValueDto(bool? Active = null, AggregationEnum? Aggregation = null, ColumnTypeEnum? ColumnType = null, string Name = null)
        {
            // to ensure "Active" is required (not null)
            if (Active == null)
            {
                throw new InvalidDataException("Active is a required property for PivotViewDefinitionValueDto and cannot be null");
            }
            else
            {
                this.Active = Active;
            }
            // to ensure "Aggregation" is required (not null)
            if (Aggregation == null)
            {
                throw new InvalidDataException("Aggregation is a required property for PivotViewDefinitionValueDto and cannot be null");
            }
            else
            {
                this.Aggregation = Aggregation;
            }
            // to ensure "Name" is required (not null)
            if (Name == null)
            {
                throw new InvalidDataException("Name is a required property for PivotViewDefinitionValueDto and cannot be null");
            }
            else
            {
                this.Name = Name;
            }
            this.ColumnType = ColumnType;
        }
        
        /// <summary>
        /// Gets or Sets Active
        /// </summary>
        [DataMember(Name="active", EmitDefaultValue=false)]
        public bool? Active { get; set; }
        /// <summary>
        /// Name of the pivot view value. The maximum size is 255 characters.
        /// </summary>
        /// <value>Name of the pivot view value. The maximum size is 255 characters.</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PivotViewDefinitionValueDto {\n");
            sb.Append("  Active: ").Append(Active).Append("\n");
            sb.Append("  Aggregation: ").Append(Aggregation).Append("\n");
            sb.Append("  ColumnType: ").Append(ColumnType).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as PivotViewDefinitionValueDto);
        }

        /// <summary>
        /// Returns true if PivotViewDefinitionValueDto instances are equal
        /// </summary>
        /// <param name="other">Instance of PivotViewDefinitionValueDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PivotViewDefinitionValueDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Active == other.Active ||
                    this.Active != null &&
                    this.Active.Equals(other.Active)
                ) && 
                (
                    this.Aggregation == other.Aggregation ||
                    this.Aggregation != null &&
                    this.Aggregation.Equals(other.Aggregation)
                ) && 
                (
                    this.ColumnType == other.ColumnType ||
                    this.ColumnType != null &&
                    this.ColumnType.Equals(other.ColumnType)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Active != null)
                    hash = hash * 59 + this.Active.GetHashCode();
                if (this.Aggregation != null)
                    hash = hash * 59 + this.Aggregation.GetHashCode();
                if (this.ColumnType != null)
                    hash = hash * 59 + this.ColumnType.GetHashCode();
                if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                return hash;
            }
        }
    }

}
