/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// QueryTextDto
    /// </summary>
    [DataContract]
    public partial class QueryTextDto :  IEquatable<QueryTextDto>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="QueryTextDto" /> class.
        /// </summary>
        /// <param name="QueryText">queryText to be parsed, if present and valid..</param>
        public QueryTextDto(string QueryText = null)
        {
            this.QueryText = QueryText;
        }
        
        /// <summary>
        /// queryText to be parsed, if present and valid.
        /// </summary>
        /// <value>queryText to be parsed, if present and valid.</value>
        [DataMember(Name="queryText", EmitDefaultValue=false)]
        public string QueryText { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class QueryTextDto {\n");
            sb.Append("  QueryText: ").Append(QueryText).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as QueryTextDto);
        }

        /// <summary>
        /// Returns true if QueryTextDto instances are equal
        /// </summary>
        /// <param name="other">Instance of QueryTextDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(QueryTextDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.QueryText == other.QueryText ||
                    this.QueryText != null &&
                    this.QueryText.Equals(other.QueryText)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.QueryText != null)
                    hash = hash * 59 + this.QueryText.GetHashCode();
                return hash;
            }
        }
    }

}
