/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SpreadsheetInfoDto
    /// </summary>
    [DataContract]
    public partial class SpreadsheetInfoDto :  IEquatable<SpreadsheetInfoDto>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpreadsheetInfoDto" /> class.
        /// </summary>
        /// <param name="SheetId">The unique identifier of the sheet.</param>
        /// <param name="WorkbookId">The unique identifier of the workbook.</param>
        public SpreadsheetInfoDto(string SheetId = null, string WorkbookId = null)
        {
            this.SheetId = SheetId;
            this.WorkbookId = WorkbookId;
        }
        
        /// <summary>
        /// The unique identifier of the sheet
        /// </summary>
        /// <value>The unique identifier of the sheet</value>
        [DataMember(Name="sheetId", EmitDefaultValue=false)]
        public string SheetId { get; set; }
        /// <summary>
        /// The unique identifier of the workbook
        /// </summary>
        /// <value>The unique identifier of the workbook</value>
        [DataMember(Name="workbookId", EmitDefaultValue=false)]
        public string WorkbookId { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SpreadsheetInfoDto {\n");
            sb.Append("  SheetId: ").Append(SheetId).Append("\n");
            sb.Append("  WorkbookId: ").Append(WorkbookId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as SpreadsheetInfoDto);
        }

        /// <summary>
        /// Returns true if SpreadsheetInfoDto instances are equal
        /// </summary>
        /// <param name="other">Instance of SpreadsheetInfoDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SpreadsheetInfoDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.SheetId == other.SheetId ||
                    this.SheetId != null &&
                    this.SheetId.Equals(other.SheetId)
                ) && 
                (
                    this.WorkbookId == other.WorkbookId ||
                    this.WorkbookId != null &&
                    this.WorkbookId.Equals(other.WorkbookId)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.SheetId != null)
                    hash = hash * 59 + this.SheetId.GetHashCode();
                if (this.WorkbookId != null)
                    hash = hash * 59 + this.WorkbookId.GetHashCode();
                return hash;
            }
        }
    }

}
