/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TableSchema
    /// </summary>
    [DataContract]
    public partial class TableSchema :  IEquatable<TableSchema>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TableSchema" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TableSchema() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TableSchema" /> class.
        /// </summary>
        /// <param name="Columns">list of columns in the table, must at least one in size (required).</param>
        public TableSchema(List<ColumnDto> Columns = null)
        {
            // to ensure "Columns" is required (not null)
            if (Columns == null)
            {
                throw new InvalidDataException("Columns is a required property for TableSchema and cannot be null");
            }
            else
            {
                this.Columns = Columns;
            }
        }
        
        /// <summary>
        /// list of columns in the table, must at least one in size
        /// </summary>
        /// <value>list of columns in the table, must at least one in size</value>
        [DataMember(Name="columns", EmitDefaultValue=false)]
        public List<ColumnDto> Columns { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TableSchema {\n");
            sb.Append("  Columns: ").Append(Columns).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as TableSchema);
        }

        /// <summary>
        /// Returns true if TableSchema instances are equal
        /// </summary>
        /// <param name="other">Instance of TableSchema to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TableSchema other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Columns == other.Columns ||
                    this.Columns != null &&
                    this.Columns.SequenceEqual(other.Columns)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Columns != null)
                    hash = hash * 59 + this.Columns.GetHashCode();
                return hash;
            }
        }
    }

}
