/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// UniqueConstraintDto
    /// </summary>
    [DataContract]
    public partial class UniqueConstraintDto :  IEquatable<UniqueConstraintDto>
    {
        /// <summary>
        /// Name of this unique constraint. Max length: 100
        /// </summary>
        /// <value>Name of this unique constraint. Max length: 100</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum NameEnum
        {
            
            /// <summary>
            /// Enum Columns for "key_columns"
            /// </summary>
            [EnumMember(Value = "key_columns")]
            Columns
        }

        /// <summary>
        /// Name of this unique constraint. Max length: 100
        /// </summary>
        /// <value>Name of this unique constraint. Max length: 100</value>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public NameEnum? Name { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="UniqueConstraintDto" /> class.
        /// </summary>
        /// <param name="Description">Description of this unique constraint. Max length: 1024.</param>
        /// <param name="Id">Id of the unique constraint.</param>
        /// <param name="Name">Name of this unique constraint. Max length: 100.</param>
        /// <param name="TableId">Id of the table this unique constraint is associated with.</param>
        /// <param name="Values">List of values in the unique constraint.</param>
        public UniqueConstraintDto(string Description = null, string Id = null, NameEnum? Name = null, string TableId = null, List<string> Values = null)
        {
            this.Description = Description;
            this.Id = Id;
            this.Name = Name;
            this.TableId = TableId;
            this.Values = Values;
        }
        
        /// <summary>
        /// Description of this unique constraint. Max length: 1024
        /// </summary>
        /// <value>Description of this unique constraint. Max length: 1024</value>
        [DataMember(Name="description", EmitDefaultValue=false)]
        public string Description { get; set; }
        /// <summary>
        /// Id of the unique constraint
        /// </summary>
        /// <value>Id of the unique constraint</value>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }
        /// <summary>
        /// Id of the table this unique constraint is associated with
        /// </summary>
        /// <value>Id of the table this unique constraint is associated with</value>
        [DataMember(Name="tableId", EmitDefaultValue=false)]
        public string TableId { get; set; }
        /// <summary>
        /// List of values in the unique constraint
        /// </summary>
        /// <value>List of values in the unique constraint</value>
        [DataMember(Name="values", EmitDefaultValue=false)]
        public List<string> Values { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UniqueConstraintDto {\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  TableId: ").Append(TableId).Append("\n");
            sb.Append("  Values: ").Append(Values).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as UniqueConstraintDto);
        }

        /// <summary>
        /// Returns true if UniqueConstraintDto instances are equal
        /// </summary>
        /// <param name="other">Instance of UniqueConstraintDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UniqueConstraintDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Description == other.Description ||
                    this.Description != null &&
                    this.Description.Equals(other.Description)
                ) && 
                (
                    this.Id == other.Id ||
                    this.Id != null &&
                    this.Id.Equals(other.Id)
                ) && 
                (
                    this.Name == other.Name ||
                    this.Name != null &&
                    this.Name.Equals(other.Name)
                ) && 
                (
                    this.TableId == other.TableId ||
                    this.TableId != null &&
                    this.TableId.Equals(other.TableId)
                ) && 
                (
                    this.Values == other.Values ||
                    this.Values != null &&
                    this.Values.SequenceEqual(other.Values)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Description != null)
                    hash = hash * 59 + this.Description.GetHashCode();
                if (this.Id != null)
                    hash = hash * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hash = hash * 59 + this.Name.GetHashCode();
                if (this.TableId != null)
                    hash = hash * 59 + this.TableId.GetHashCode();
                if (this.Values != null)
                    hash = hash * 59 + this.Values.GetHashCode();
                return hash;
            }
        }
    }

}
