/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ValidateFilesDto
    /// </summary>
    [DataContract]
    public partial class ValidateFilesDto :  IEquatable<ValidateFilesDto>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidateFilesDto" /> class.
        /// </summary>
        /// <param name="DeletedFiles">A list of files that were deleted during the validation because not enough information was available to repair them. These files will no longer be available via the endpoint and will not be included in queries..</param>
        /// <param name="RepairedFiles">A list of files that were modified during the validation and will continue to be visible and to be usable in the account..</param>
        public ValidateFilesDto(List<FileMetaDto> DeletedFiles = null, List<FileMetaDto> RepairedFiles = null)
        {
            this.DeletedFiles = DeletedFiles;
            this.RepairedFiles = RepairedFiles;
        }
        
        /// <summary>
        /// A list of files that were deleted during the validation because not enough information was available to repair them. These files will no longer be available via the endpoint and will not be included in queries.
        /// </summary>
        /// <value>A list of files that were deleted during the validation because not enough information was available to repair them. These files will no longer be available via the endpoint and will not be included in queries.</value>
        [DataMember(Name="deletedFiles", EmitDefaultValue=false)]
        public List<FileMetaDto> DeletedFiles { get; set; }
        /// <summary>
        /// A list of files that were modified during the validation and will continue to be visible and to be usable in the account.
        /// </summary>
        /// <value>A list of files that were modified during the validation and will continue to be visible and to be usable in the account.</value>
        [DataMember(Name="repairedFiles", EmitDefaultValue=false)]
        public List<FileMetaDto> RepairedFiles { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ValidateFilesDto {\n");
            sb.Append("  DeletedFiles: ").Append(DeletedFiles).Append("\n");
            sb.Append("  RepairedFiles: ").Append(RepairedFiles).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as ValidateFilesDto);
        }

        /// <summary>
        /// Returns true if ValidateFilesDto instances are equal
        /// </summary>
        /// <param name="other">Instance of ValidateFilesDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValidateFilesDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.DeletedFiles == other.DeletedFiles ||
                    this.DeletedFiles != null &&
                    this.DeletedFiles.SequenceEqual(other.DeletedFiles)
                ) && 
                (
                    this.RepairedFiles == other.RepairedFiles ||
                    this.RepairedFiles != null &&
                    this.RepairedFiles.SequenceEqual(other.RepairedFiles)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.DeletedFiles != null)
                    hash = hash * 59 + this.DeletedFiles.GetHashCode();
                if (this.RepairedFiles != null)
                    hash = hash * 59 + this.RepairedFiles.GetHashCode();
                return hash;
            }
        }
    }

}
