/* 
 * Cerebral API
 *
 * The Wdata Preparation API allow users to import data sets from their source system, tag, organize, manipulate, share, export, and query against the data
 *
 * OpenAPI spec version: 1.0
 * Contact: platformsupport@workiva.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ValidateTablesDto
    /// </summary>
    [DataContract]
    public partial class ValidateTablesDto :  IEquatable<ValidateTablesDto>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ValidateTablesDto" /> class.
        /// </summary>
        /// <param name="DeletedTables">A list of tables that were deleted during the validation because not enough information was available to repair them. These tables will no longer be available via the endpoint and queries using these tables will cease to function properly..</param>
        /// <param name="RepairedTables">A list of tables that were modified during the validation and will continue to be visible and to be usable in the account..</param>
        public ValidateTablesDto(List<TableDto> DeletedTables = null, List<TableDto> RepairedTables = null)
        {
            this.DeletedTables = DeletedTables;
            this.RepairedTables = RepairedTables;
        }
        
        /// <summary>
        /// A list of tables that were deleted during the validation because not enough information was available to repair them. These tables will no longer be available via the endpoint and queries using these tables will cease to function properly.
        /// </summary>
        /// <value>A list of tables that were deleted during the validation because not enough information was available to repair them. These tables will no longer be available via the endpoint and queries using these tables will cease to function properly.</value>
        [DataMember(Name="deletedTables", EmitDefaultValue=false)]
        public List<TableDto> DeletedTables { get; set; }
        /// <summary>
        /// A list of tables that were modified during the validation and will continue to be visible and to be usable in the account.
        /// </summary>
        /// <value>A list of tables that were modified during the validation and will continue to be visible and to be usable in the account.</value>
        [DataMember(Name="repairedTables", EmitDefaultValue=false)]
        public List<TableDto> RepairedTables { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ValidateTablesDto {\n");
            sb.Append("  DeletedTables: ").Append(DeletedTables).Append("\n");
            sb.Append("  RepairedTables: ").Append(RepairedTables).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as ValidateTablesDto);
        }

        /// <summary>
        /// Returns true if ValidateTablesDto instances are equal
        /// </summary>
        /// <param name="other">Instance of ValidateTablesDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ValidateTablesDto other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.DeletedTables == other.DeletedTables ||
                    this.DeletedTables != null &&
                    this.DeletedTables.SequenceEqual(other.DeletedTables)
                ) && 
                (
                    this.RepairedTables == other.RepairedTables ||
                    this.RepairedTables != null &&
                    this.RepairedTables.SequenceEqual(other.RepairedTables)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.DeletedTables != null)
                    hash = hash * 59 + this.DeletedTables.GetHashCode();
                if (this.RepairedTables != null)
                    hash = hash * 59 + this.RepairedTables.GetHashCode();
                return hash;
            }
        }
    }

}
